//
//  CompanyInfoModel.swift
//  JobThai
//
//  Created by weerapon on 4/11/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

class CompanyInfoModel {
    
    var title : String?
    var type : JobDetailCellType?
    var isHasData : Bool?
    
    init(itemInfo : NSMutableDictionary) {
        self.title = itemInfo.objectForKey("title") as? String
        self.type = CompanyInfoModel.getType(itemInfo)
    }
    
    static func getType(itemInfo : NSMutableDictionary) -> JobDetailCellType {
        let typeCode = itemInfo.objectForKey("type") as? Int
        return JobDetailCellType(rawValue: typeCode!)!
    }
    

    func getIfCellHasData() -> Bool {
        return true
    }
    
}

class CompanyInfoImageModel : CompanyInfoModel {
    var valueInfo = [String]()
    
    override init(itemInfo: NSMutableDictionary) {
        super.init(itemInfo: itemInfo)
        self.valueInfo = itemInfo.objectForKey("value") as? [String] == nil ? [] : (itemInfo.objectForKey("value") as? [String])!
        self.isHasData = getIfCellHasData()
    }
    
    override func getIfCellHasData() -> Bool {
        return self.valueInfo.count > 0
    }
}

class CompanyInfoTextModel : CompanyInfoModel {
    var valueInfo : String?
    
    override init(itemInfo: NSMutableDictionary) {
        super.init(itemInfo: itemInfo)
        self.valueInfo = itemInfo.objectForKey("value") as? String == nil ? "" : itemInfo.objectForKey("value") as? String
        self.isHasData = getIfCellHasData()
    }
    
    override func getIfCellHasData() -> Bool {
        return (self.valueInfo != "")
    }
}