//
//  JTMActivityProvider.swift
//  JobThai
//
//  Created by kanya on 7/7/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMActivityProvider: UIActivityItemProvider {
    
    override init(placeholderItem: AnyObject) {
        super.init(placeholderItem: placeholderItem)
    }
    
    override func activityViewController(activityViewController: UIActivityViewController, itemForActivityType activityType: String) -> AnyObject? {
        
        let placeholder = self.placeholderItem as! [String : AnyObject]
        let jobItem = placeholder["jobItem"] as! PositionModel
        let companyName = placeholder["companyName"] as! String
        
        if (activityType == "com.apple.UIKit.activity.Mail") {
            return getEmailBodyForJob(jobItem, company: companyName)
        } else {
            return NSURL(string: jobItem.jobLink!)
        }
    }
    
    //MARK:- Email Content
    func getEmailBodyForJob(jobItem: PositionModel, company: String) -> String {
        
        let HTML_OPEN_TAG = "<html><boody>"
        let HTML_CLOSE_TAG = "</body></html>"
        let HTML_NEW_LINE_TAG = "<br>"
    
        let emailContentPrefix = applicationDelegate.getLocalizeStringForKey("SHARE_JOB_EMAIL_CONTENT_PREFIX")
        let emailContentLinkPrefix = applicationDelegate.getLocalizeStringForKey("SHARE_JOB_EMAIL_LINK_PREFIX")
        let emailLinkHTML = "<a href=\"\(jobItem.jobLink!)\">\(jobItem.jobLink!)</a>"
        let emailContentSuffix = applicationDelegate.getLocalizeStringForKey("SHARE_JOB_EMAIL_CONTENT_SUFFIX")
        let emailContentWriter = applicationDelegate.getLocalizeStringForKey("SHARE_JOB_EMAIL_WRITER")
        
        let emailContent =  HTML_OPEN_TAG +
                            emailContentPrefix + HTML_NEW_LINE_TAG + HTML_NEW_LINE_TAG +
                            jobItem.jobTitle! + HTML_NEW_LINE_TAG +
                            company + HTML_NEW_LINE_TAG +
                            jobItem.workLocation! + HTML_NEW_LINE_TAG +
                            jobItem.numberOfPosition! + HTML_NEW_LINE_TAG + HTML_NEW_LINE_TAG +
                            emailContentLinkPrefix + HTML_NEW_LINE_TAG +
                            emailLinkHTML + HTML_NEW_LINE_TAG + HTML_NEW_LINE_TAG +
                            emailContentSuffix + HTML_NEW_LINE_TAG +
                            emailContentWriter + HTML_NEW_LINE_TAG +
                            HTML_CLOSE_TAG
        
        return emailContent
    }
}
