//
//  JTMAllPositionMapJobCollectionViewCell.swift
//  JobThai
//
//  Created by pizhayut on 7/7/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMAllPositionMapJobCollectionViewCell: UICollectionViewCell {
    
    @IBOutlet weak var sequence: UILabel!
    @IBOutlet weak var dateJob: UILabel!
    @IBOutlet weak var positionJob: UILabel!
    @IBOutlet weak var country: UILabel!
    @IBOutlet weak var salary: UILabel!
    @IBOutlet weak var salaryImage: UIImageView!
    @IBOutlet weak var companyNameLabel: UILabel!
    @IBOutlet weak var companyLogoImage: UIImageView!
    @IBOutlet weak var stackView: UIStackView!
    @IBOutlet weak var bottomBorderView: UIView!
    @IBOutlet weak var topBorderView: UIView!
    @IBOutlet weak var topBorderHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var bottomBorderHeightConstraint: NSLayoutConstraint!
    
    let SELECTED_BODER_WIDTH: CGFloat = 2.5
    let BORDER_WIDTH: CGFloat = JTM_CELL_BORDER_HEIGHT//2
    let CELL_PADDING: CGFloat = 8
    let BORDER_COLOR : UIColor = JTM_CELL_SEPERATOR_COLOR//JTM_BROWSEJOB_HOME_BG_COLOR
    let SELECTED_BG_COLOR = JTM_HIGHLIGHT_COLOR
    
    override func awakeFromNib() {
//        stackView.translatesAutoresizingMaskIntoConstraints = false
//        let constraint = NSLayoutConstraint(item: stackView, attribute: .Width, relatedBy: .Equal, toItem: nil, attribute: .NotAnAttribute, multiplier: 1, constant: DEFAULT_FRAME_WIDTH - DEFAULT_CELL_MARGIN - CELL_PADDING*2)
//        stackView.addConstraint(constraint)
        
        //super.awakeFromNib()
        
        setCellBorder()
//        self.setSelectedBackgroundView()
        
    }
    
    func setCellBorder() {
//        let view = UIView(frame: CGRectMake(0, 0, self.frame.width, self.frame.height))
//        view.layer.borderWidth = SELECTED_BODER_WIDTH
//        view.layer.borderColor = BORDER_COLOR.CGColor
//        self.selectedBackgroundView = view
//        
//        self.layer.borderColor = BORDER_COLOR.CGColor
//        self.layer.borderWidth = BORDER_WIDTH
        
        //top border
        self.topBorderView.backgroundColor = BORDER_COLOR
        self.topBorderHeightConstraint.constant = BORDER_WIDTH
        
        //set bottom border
        self.bottomBorderView.backgroundColor = BORDER_COLOR
        self.bottomBorderHeightConstraint.constant = BORDER_WIDTH
    }
    
    func setDataCell(itemJob : JobItem, sequence : Int) {
        self.sequence?.text = "\(sequence)"
        self.topBorderHeightConstraint.constant = (sequence == 1) ? BORDER_WIDTH : 0
        self.dateJob?.text = itemJob.dateText
        self.positionJob?.text = itemJob.jobTitle
        self.companyNameLabel.text = itemJob.companyName
        self.country?.text = (itemJob.contryCode == "TH") ? itemJob.provice : itemJob.national
        self.country.sizeToFit()
        self.salary?.text = itemJob.salary
        self.salaryImage.hidden = (itemJob.salary == "")
        
        if let logoImage = itemJob.companyLogo {
            self.companyLogoImage.sd_setImageWithURL(logoImage, placeholderImage: UIImage())
            self.companyLogoImage.hidden = false
        } else {
            self.companyLogoImage.hidden = true
        }
    }
    
    func setSelectedBackgroundView() {
        
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = SELECTED_BG_COLOR
        
        self.selectedBackgroundView = backgroundView
    }

}
