//
//  JTMAppliedJobCollectionViewCell.swift
//  JobThai
//
//  Created by tayathorn on 5/13/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMAppliedJobCollectionViewCell: UICollectionViewCell {

    @IBOutlet weak var imageCompany: UIImageView!
    @IBOutlet weak var sequence: JTMLabel!
    @IBOutlet weak var date: JTMLabel!
    @IBOutlet weak var datePrefix: JTMLabel!
    @IBOutlet weak var positionJob: JTMLabel!
    @IBOutlet weak var companyName: JTMLabel!
    @IBOutlet weak var province: JTMLabel!
    @IBOutlet weak var salary: JTMLabel!
    @IBOutlet weak var closedJobImage: UIImageView!
    @IBOutlet weak var salaryImage: UIImageView!
    @IBOutlet weak var bottomBorderView: UIView!
    @IBOutlet weak var topBorderView: UIView!
    @IBOutlet weak var topBorderHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var bottomBorderHeightConstraint: NSLayoutConstraint!
    
    let SELECTED_BODER_WIDTH: CGFloat = 2.5
    let BORDER_WIDTH: CGFloat = JTM_CELL_BORDER_HEIGHT//2
    let BORDER_COLOR = JTM_CELL_SEPERATOR_COLOR//JTM_BROWSEJOB_HOME_BG_COLOR
    
    func setDataToCell(item : AppliedJobItem, sequence : Int) {
        self.sequence.text = "\(sequence+1)"
        self.topBorderHeightConstraint.constant = (sequence == 0) ? BORDER_WIDTH : 0
        self.date.text = item.date
        self.datePrefix.text = applicationDelegate.getLocalizeStringForKey("APPLIED_DATE_PREFIX")
        
        self.imageCompany.hidden = !(item.companyLogo != nil)
        
        if item.companyLogo != nil {
            self.imageCompany?.sd_setImageWithURL(item.companyLogo!, placeholderImage: UIImage())
        }
        self.positionJob.text = item.jobTitle
        self.companyName.text = item.companyName
        
        self.province.text = (item.countryCode == "TH") ? item.province : item.national
        
        self.salary.text = item.salary
        self.salary.hidden = (item.salary == "")
        self.salaryImage.hidden = (item.salary == "")
        
        self.closedJobImage.image = UIImage(named: applicationDelegate.getLocalizeStringForKey("CLOSED_JOB_IMAGE"))
        self.closedJobImage.hidden = (item.onlineStatus! == "1")

        // FOR UI TEST
        self.closedJobImage.accessibilityIdentifier = (item.onlineStatus! == "1") ? "closedJobImage_AVAIL" : "closedJobImage_CLOSED"
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.setCellBorder()
//        self.setSelectedBackgroundView()
    }
    
    func setCellBorder() {
//        self.layer.borderWidth = BORDER_WIDTH
//        self.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        
        //top border
        self.topBorderView.backgroundColor = BORDER_COLOR
        self.topBorderHeightConstraint.constant = BORDER_WIDTH
        
        // bottom border
        self.bottomBorderView.backgroundColor = BORDER_COLOR
        self.bottomBorderHeightConstraint.constant = BORDER_WIDTH
    }
    
    func setSelectedBackgroundView() {
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = UIColor.clearColor()
        backgroundView.layer.borderWidth = SELECTED_BODER_WIDTH
        backgroundView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        
        self.selectedBackgroundView = backgroundView
    }
    
}
