//
//  JTMApplyNowView.swift
//  ApplyNow
//
//  Created by HARIKAN on 4/4/16.
//  Copyright © 2016 HARIKAN. All rights reserved.
//

import UIKit

class JTMApplyNowView: UIView, UITextViewDelegate {
    var jobData: PositionModel?
    var companyName: String?
    var delegate:DelegateApplyNow?
    let xibNameApplyNow = "JTMApplyNowView"
    
    @IBOutlet var headNoteApplyNow: JTMLabel!
    @IBOutlet var headCompanyApplyNow: JTMLabel!
    @IBOutlet var companyApplyNow: JTMLabel!
    @IBOutlet var headPositionApplyNow: JTMLabel!
    @IBOutlet var positionApplyNow: JTMLabel!
    @IBOutlet var ccMailTextApplyNow: JTMLabel!
    @IBOutlet var buttonApplyNow: JTMButton!
    @IBOutlet var countNoteLabel: JTMLabel!
    @IBOutlet var view: UIView!
    @IBOutlet var ccMailAppleNow: UISwitch!
    @IBOutlet var noteApplyNow: UITextView!
    @IBOutlet var UIViewButtonApplyNow: UIView!
    
    let HEAD_NOTE_XIB_APPLYNOW = "HEAD_NOTE_XIB_APPLYNOW"
    let COMPANY_XIB_APPLYNOW = "COMPANY_XIB_APPLYNOW"
    let POSITION_XIB_APPLYNOW = "POSITION_XIB_APPLYNOW"
    let NOTE_CCMAIL_XIB_APPLYNOW = "NOTE_CCMAIL_XIB_APPLYNOW"
    let BUTTON_APPLY_XIB_APPLYNOW = "BUTTON_APPLY_XIB_APPLYNOW"
    
    let ALERT_TITLE_APPLYNOW = "ALERT_TITLE_APPLYNOW"
    let ALERT_SUCCESS_APPLYNOW = "ALERT_SUCCESS_APPLYNOW"
    let ALERT_DIMISS = "ALERT_DIMISS"
    

    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        self.loadViewApplyNow()
        setLocalize()
        addGestureCilck()
        self.noteApplyNow.delegate = self
        self.countNoteLabel.text = "0"
        setUIApplyButton()
    }
    
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        noteApplyNow.resignFirstResponder()
    }
    
    func loadViewApplyNow(){
        UINib(nibName: xibNameApplyNow, bundle: nil).instantiateWithOwner(self, options: nil)
        view.frame = self.bounds
        view.autoresizingMask = [.FlexibleWidth,.FlexibleHeight]
        addSubview(view)
        self.noteApplyNow.layer.borderColor = UIColor(hexString: "#CCCCCC").CGColor
        self.noteApplyNow.layer.borderWidth = 1
    }
    
    func setLocalize(){
        headNoteApplyNow.text =  applicationDelegate.getLocalizeStringForKey(HEAD_NOTE_XIB_APPLYNOW)
        headCompanyApplyNow.text = applicationDelegate.getLocalizeStringForKey(COMPANY_XIB_APPLYNOW)
        headPositionApplyNow.text = applicationDelegate.getLocalizeStringForKey(POSITION_XIB_APPLYNOW)
        ccMailTextApplyNow.text = applicationDelegate.getLocalizeStringForKey(NOTE_CCMAIL_XIB_APPLYNOW)
        let textTitleButtonAppleNow = applicationDelegate.getLocalizeStringForKey(BUTTON_APPLY_XIB_APPLYNOW)
        buttonApplyNow.setTitle(textTitleButtonAppleNow, forState: .Normal)
    }
    
    func setValue(companyName: String, jobData:PositionModel){
        self.companyName = companyName
        self.jobData = jobData
        setDataApplyNow()
    }
    
    func setDataApplyNow(){
        self.companyApplyNow.text = companyName
        self.positionApplyNow.text = jobData?.jobTitle
    }
    
    func addGestureCilck(){
        let tap = UITapGestureRecognizer(target: self , action: #selector(onClickApplyNowButton))
        tap.numberOfTapsRequired = 1
        self.UIViewButtonApplyNow.addGestureRecognizer(tap)
    }
    
    func setUIApplyButton(){
        self.UIViewButtonApplyNow.layer.cornerRadius = 4
    }
    
    func onClickApplyNowButton(){
        delegate?.onClickApplyNowButton(UIViewButtonApplyNow, note: noteApplyNow.text, countString: self.countNoteLabel.text!,isSendEmail: ccMailAppleNow.on)
//        callServiceApplyNow()
//        
//        let alertTitleApplyNowLocalize = applicationDelegate.getLocalizeStringForKey("ALERT_TITLE_APPLYNOW")
//        let alertTextApplyNowLocalize = applicationDelegate.getLocalizeStringForKey("ALERT_SUCCESS_APPLYNOW")
//        let alertDimissApplyNowLocalize = applicationDelegate.getLocalizeStringForKey("OK")
//        delegate.alertApplyNow(alertTitleApplyNowLocalize,alertTextApplyNow: alertTextApplyNowLocalize, alertDimissApplyNow: alertDimissApplyNowLocalize)
    }
    
//    func callServiceApplyNow(){
//        
//    }

    func textView(textView: UITextView, shouldChangeTextInRange range: NSRange, replacementText text: String) -> Bool {
        let length = (textView.text.utf16).count + (text.utf16).count - range.length
        
        if(length <= 200) {
            countNoteLabel.text = String(length)
            return true
        }
        
        return false
    }

}

protocol DelegateApplyNow{
    func onClickApplyNowButton(button: UIView, note: String, countString : String, isSendEmail: Bool)
//    func alertLogInApplyNow()
//    func alertApplyNow(alertTitleApplyNow:String, alertTextApplyNow:String , alertDimissApplyNow:String )
}