//
//  JTMAreaJobNearMeTableViewCell.swift
//  JobThai
//
//  Created by ForAlL on 2/29/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMAreaJobNearMeTableViewCell: UITableViewCell {

    @IBOutlet weak var titleArea: JTMLabel?
    @IBOutlet weak var prefixArea: JTMLabel?
    @IBOutlet weak var slider:UISlider?
    
    let CONSTANT_ONE = 1
    let CONSTANT_TWO = 2
    let CONSTANT_THREE = 3
    let CONSTANT_FOUR = 4
    let CONSTANT_FIVE = 5
    let CONSTANT_SIX = 6
    let CONSTANT_SEVEN = 7
    
    var startIndex = 4
    var arrayRadius = [0, 0.5, 1, 3, 5, 10, 15, 20]
    var delegate : JTMAreaJobNearMeDelegate?
    
    override func awakeFromNib() {
        super.awakeFromNib()
        
        // Initialization code
        self.titleArea!.text = applicationDelegate.getLocalizeStringForKey("TITLE_AREA_JOB_NEAR_ME_FRONT")
        setPrefixAreaText(arrayRadius[startIndex])
        self.addUITabGesture()
        self.setEdgeToLeft()
    }
    
    private func addUITabGesture() {
        let tap : UITapGestureRecognizer = UITapGestureRecognizer(target: self, action: #selector(sliderTappedAction(_:)))
        tap.delegate = self
        slider?.addGestureRecognizer(tap)
        slider?.userInteractionEnabled = true
    }
    
    // Mark :: Slide Set Value
    @IBAction func sliderValueChanged(sender: UISlider) {
        // if over 0.5 round up and less than 0.5 flick down
        let index = (Int)(slider!.value + 0.5)
        self.setValeSider(index)
    }
    
    // Mark :: Click Button Set Value
    @IBAction func onClickButtonOne() {
        self.setValeSider(CONSTANT_ONE)
    }
    
    @IBAction func onClickButtonTwo() {
        self.setValeSider(CONSTANT_TWO)
    }
    
    @IBAction func onClickButtonThree() {
        self.setValeSider(CONSTANT_THREE)
    }
    
    @IBAction func onClickButtonFour() {
        self.setValeSider(CONSTANT_FOUR)
    }
    
    @IBAction func onClickButtonFive() {
        self.setValeSider(CONSTANT_FIVE)
    }
    
    @IBAction func onClickButtonSix() {
        self.setValeSider(CONSTANT_SIX)
    }
    
    @IBAction func onClickButtonSeven() {
        self.setValeSider(CONSTANT_SEVEN)
    }
    
    // Mark :: Set Value
    private func setValeSider(index : Int) {
        slider?.setValue(Float(index), animated: false)
        let number = arrayRadius[index]
        if (startIndex != index) {
            setPrefixAreaText(number)
            delegate?.onValueAreaChanged(Int(1000 * number))
            startIndex = index
        }
    }
    
    // Mark :: Function Selector UITapGestureRecognizer
    func sliderTappedAction(sender: UITapGestureRecognizer) {
        let point = sender.locationInView(slider)
        var index = (Int)(Float(((point.x / CGRectGetWidth(slider!.bounds)) * 100)/14.285714286) + 0.5)
        if index == 0 {
            index = 1
        }
        self.setValeSider(index)
    }
    
    func setPrefixAreaText(value:Double) {
        
        self.prefixArea?.text = applicationDelegate.numFormatter.stringFromNumber(value)! + " " + applicationDelegate.getLocalizeStringForKey("TITLE_AREA_JOB_NEAR_ME_BACK")
    }
    
    func setSliderValueTo(value:Int) {
        let index = arrayRadius.indexOf(Double(value)/1000)
        setValeSider(Int(index!))
    }
}

protocol JTMAreaJobNearMeDelegate {
    func onValueAreaChanged(value : Int)
}
