//
//  JTMBrowseJobCareersView.swift
//  JobThai
//
//  Created by ForAlL on 1/20/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMBrowseJobCareersView: UIView,UICollectionViewDelegate, UICollectionViewDataSource {

 
    // Declare Variable
    @IBOutlet weak var titleBrowseJobCareer:JTMLabel?
    @IBOutlet weak var browseJobCareersCollection : UICollectionView?
    @IBOutlet weak var browseJobCareerCollectionViewHeightConstraint: NSLayoutConstraint!
    
    var delegate : JTMBrowseJobCareersViewDelagate?
    var careerListData : [BrowseJobCareerJobModel]?
    var numOfData : Int? = 0
    
    var view: UIView!
    
    var currentIndex : Int? = -1
    
    let PADDING : CGFloat = 10
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMBrowseJobCareersView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        browseJobCareersCollection?.delegate = self
        browseJobCareersCollection?.dataSource = self
        // Initialization code
        browseJobCareersCollection?.registerNib(UINib(nibName: "JTMCareersCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMCareersCollectionViewCell")
    }
    
    func setModelCareers(careerList : [BrowseJobCareerJobModel]) {
        self.titleBrowseJobCareer?.text = applicationDelegate.getLocalizeStringForKey("CAREER_TITLE")
        self.careerListData = careerList
        numOfData = self.careerListData?.count
        browseJobCareersCollection?.reloadData()
        updateUI()
    }
    
    func updateUI() {
        titleBrowseJobCareer?.sizeToFit()
        browseJobCareerCollectionViewHeightConstraint.constant = (browseJobCareersCollection?.collectionViewLayout.collectionViewContentSize().height)!
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
       
        let cell = browseJobCareersCollection?.cellForItemAtIndexPath(indexPath) as? JTMCareersCollectionViewCell
        cell?.setHighlightCell(true)
        
        currentIndex = indexPath.row

//        if(currentIndex != indexPath.row){
//            cell?.setHighlightCell(true)
//            //Disable Highlight Old Cell
//            if(currentIndex != -1) {
//                let oldCell = browseJobCareersCollection?.cellForItemAtIndexPath(NSIndexPath(forRow: currentIndex!, inSection:indexPath.section)) as? JTMCareersCollectionViewCell
//                if(cell != nil){
//                    oldCell?.setHighlightCell(false)
//                }
//            }
//            currentIndex = indexPath.row
//        }

        delegate?.onBrowseJobCareersClick(self, careerData: self.careerListData![indexPath.row])
        
    }
    
    func collectionView(collectionView: UICollectionView, didHighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = browseJobCareersCollection?.cellForItemAtIndexPath(indexPath) as? JTMCareersCollectionViewCell
            cell!.setHighlightCell(true)

    }
    
    func collectionView(collectionView: UICollectionView, didUnhighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = browseJobCareersCollection?.cellForItemAtIndexPath(indexPath) as? JTMCareersCollectionViewCell
        cell!.setHighlightCell(false)
    }

    //UICollectionview Delegate
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return numOfData!
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("JTMCareersCollectionViewCell", forIndexPath: indexPath) as! JTMCareersCollectionViewCell
        cell.bindModelToCell(careerListData![indexPath.row])
        return cell
    }
    
    func collectionView(collectionView: UICollectionView,layout collectionViewLayout: UICollectionViewLayout,sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        var widthCell : Double = 0
        let heightCell : Double = 135
        let widthSpace : Double = 10
        let numOfCell : Double = 4
        let numOfSpace : Double = 3
        
        widthCell = (Double((browseJobCareersCollection?.frame.size.width)!) - (widthSpace*numOfSpace))/numOfCell
        return CGSize(width: widthCell, height: heightCell)
    }
    
    func collectionView(collectionView: UICollectionView,layout collectionViewLayout: UICollectionViewLayout,minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
        return PADDING
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAtIndex section: Int) -> CGFloat {
        return PADDING
    }
    
    func deSelectItem(indexPath:NSIndexPath) {
        let cell = browseJobCareersCollection?.cellForItemAtIndexPath(indexPath) as? JTMCareersCollectionViewCell
        cell?.setHighlightCell(false)
        currentIndex = -1
    }
}

protocol JTMBrowseJobCareersViewDelagate {
    func onBrowseJobCareersClick(browseJobCareers : JTMBrowseJobCareersView, careerData : BrowseJobCareerJobModel)
}
