//
//  JTMCareersCollectionViewCell.swift
//  JobThai
//
//  Created by ForAlL on 1/20/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMCareersCollectionViewCell: UICollectionViewCell {
    
    
    @IBOutlet weak var icon:UIImageView?
    @IBOutlet weak var careerName:JTMLabel?
    @IBOutlet weak var countPosition:JTMLabel?
    @IBOutlet weak var positionUnit:JTMLabel?
    
    var normalStateColor = JTM_SELECTED_CELL_BORDER_COLOR
    var selectedStateColor = JTM_CORE_ORANGE
    
    override func awakeFromNib() {
        setUIBorder()
    }
    
    func setUIBorder() {
        self.layer.borderWidth = 1
        self.layer.borderColor = normalStateColor.CGColor
        self.layer.cornerRadius = 4
    }
        
    func bindModelToCell(careerModel:BrowseJobCareerJobModel){
       
        careerName?.text = careerModel.nameTh;
        
        if(applicationDelegate.appSetting?.currentLanguage == .THAI) {
            careerName?.text = careerModel.nameTh;
        }else {
            careerName?.text = careerModel.nameEn;
        }
        
        positionUnit?.text = applicationDelegate.getLocalizeStringForKey("POSITION_UNIT")
        countPosition?.text = applicationDelegate.numFormatter.stringFromNumber(careerModel.position!)
        icon?.image = careerModel.image
    }
    
    
    func setHighlightCell(enable : Bool) {
        if(enable) {
            self.layer.borderColor = selectedStateColor.CGColor
            self.careerName?.textColor = JTM_CORE_ORANGE
            self.positionUnit?.textColor = JTM_CORE_ORANGE
//            self.careerName?.textColor = UIColor.whiteColor()
//            self.countPosition?.textColor = UIColor.whiteColor()
//            self.positionUnit?.textColor = UIColor.whiteColor()
//            self.backgroundColor = themeColor
        } else {
            self.layer.borderColor = normalStateColor.CGColor
            self.careerName?.textColor = UIColor.blackColor()
            self.positionUnit?.textColor = UIColor.blackColor()
//            self.careerName?.textColor = UIColor.blackColor()
//            self.countPosition?.textColor = themeColor
//            self.positionUnit?.textColor = UIColor.blackColor()
//            self.backgroundColor = UIColor(hexString: "E1E1E1")
        }
    }
    
}
