//
//  JTMChagePasswordView.swift
//  JobThai
//
//  Created by weerapon on 2/8/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMChangePasswordView : UIView, UITextFieldDelegate {
    
    
    var view : UIView?
    var delegate : JTMChangePasswordDelegate?
    
//    @IBOutlet weak var currentPasswordLable : UILabel?
//    @IBOutlet weak var newPasswordLable : UILabel?
//    @IBOutlet weak var confirmNewPasswordLable : UILabel?
    @IBOutlet weak var savePasswordButton : JTMButton?
    @IBOutlet weak var currentPasswordTextField : JTMTextField?
    @IBOutlet weak var newPasswordTextField : JTMTextField?
    @IBOutlet weak var confirmPasswordTextField : JTMTextField?
    @IBOutlet weak var helperPasswordLabel: JTMLabel!
    
    
    @IBAction func onSavePassword() {
        self.endEditing(true)
        delegate?.onSavePassword()
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUI()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUI()
        setUILable()
    }
    
    func setupUI() {
        view = loadViewFromNib()
        view?.frame = bounds
        view?.autoresizingMask = [.FlexibleWidth, .FlexibleHeight]
        addSubview(view!)
        
        helperPasswordLabel.hidden = true
        currentPasswordTextField?.delegate = self
        newPasswordTextField?.delegate = self
        confirmPasswordTextField?.delegate = self
        
        self.currentPasswordTextField!.font = nil
        self.currentPasswordTextField!.font = self.currentPasswordTextField!.font?.fontWithSize(13)
        self.newPasswordTextField!.font = nil
        self.newPasswordTextField!.font = self.newPasswordTextField!.font?.fontWithSize(13)
        self.confirmPasswordTextField!.font = nil
        self.confirmPasswordTextField!.font = self.confirmPasswordTextField!.font?.fontWithSize(13)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMChangePasswordView", bundle: bundle)
        let view =  nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    func setUILable(){
        
        helperPasswordLabel.text = applicationDelegate.getLocalizeStringForKey("HELPER_CHANGE_PASSWORD")
        
        currentPasswordTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("CURRENT_PASSWORD")
        newPasswordTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("NEW_PASSWORD")
        confirmPasswordTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("CONFIRM_PASSWORD")
        
        savePasswordButton?.setTitle(applicationDelegate.getLocalizeStringForKey("SAVE_PASSWORD"), forState: .Normal)
    }
    
    // Dismiss Keyboard
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        view?.endEditing(true)
    }
    
    //Mark:- Textfield delegate
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        let nextTag: NSInteger = textField.tag + 1
        
        if let nextResponder: UIResponder! = textField.superview!.viewWithTag(nextTag){
            nextResponder.becomeFirstResponder()
        }else {
            textField.resignFirstResponder()
            self.onSavePassword()
        }
        
        return false
    }
    
    func textFieldDidBeginEditing(textField: UITextField) {
        
        if textField == newPasswordTextField {
            helperPasswordLabel.hidden = false
        }
    }
    
    // MARK :- Prevent COPY & PASTE
    override func canPerformAction(action: Selector, withSender sender: AnyObject?) -> Bool {
        return false
    }

    
}

protocol JTMChangePasswordDelegate {
    func onSavePassword()
}
