//
//  JTMHeaderContactUsView.swift
//  JobThai
//
//  Created by weerapon on 2/10/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMContactUsHeaderViewCell: UITableViewCell {
    
    @IBOutlet weak var iconHeaderCell : UIImageView?
    @IBOutlet weak var titleHeaderCell : JTMLabel?
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        if self.respondsToSelector(Selector("setSeparatorInset:")) {
            self.separatorInset = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setLayoutMargins:")) {
            self.layoutMargins = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setPreservesSuperviewLayoutMargins:")) {
            self.preservesSuperviewLayoutMargins = false
        }
    }
    
    func setCellHeader(title : String, pathIcon : String) {
//        self.titleHeaderCell?.text = title
        let LINE_SPACE_HEIGHT : CGFloat = 5
        self.iconHeaderCell?.image = UIImage(named: pathIcon)
        
        let companyName = title.stringByTrimmingCharactersInSet(NSCharacterSet.whitespaceAndNewlineCharacterSet()).componentsSeparatedByString("\n")[0]
        let range = (title as NSString).rangeOfString(companyName)
        let style = NSMutableParagraphStyle()
        style.lineSpacing = LINE_SPACE_HEIGHT
        
        let myMutableString = NSMutableAttributedString(string: title as String)
//        myMutableString.addAttribute(NSFontAttributeName, value: UIFont.systemFontOfSize(18), range: range)
        myMutableString.addAttribute(NSParagraphStyleAttributeName, value: style, range: range)
        
        self.titleHeaderCell?.attributedText = myMutableString

    }

}
