//
//  JTMCorporateView.swift
//  JobThai
//
//  Created by weerapon on 1/15/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
//import AlamofireImage


class JTMCorporateView : UIView, UICollectionViewDelegate, UICollectionViewDataSource, UICollectionViewDelegateFlowLayout{
    
    // Declare Variable
    @IBOutlet weak var corporateCollection : JTMCollectionView?
    var delegate : JTMCorporateViewDelagate?
    var corporateListData : [CorporateModel]?
    var numOfData : Int? = 0
    
    var view: UIView!
    var cellSize : CGSize = CGSizeMake(85, 85)
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }

    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMCorporateView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }

    override func awakeFromNib() {
        super.awakeFromNib()
        corporateCollection?.delegate = self
        corporateCollection?.dataSource = self
        // Initialization code
        corporateCollection?.registerNib(UINib(nibName: "JTMCorporateCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMCorporateCollectionViewCell")
    }
    
    func setModelCorporate(corporateList : [CorporateModel]) {
        self.corporateListData = corporateList
        numOfData = self.corporateListData?.count
        corporateCollection?.reloadData()
        
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        delegate?.onCorporateClick(self, corporateItem: self.corporateListData![indexPath.row])
    }
    
    //UICollectionview Delegate
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return numOfData!
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("JTMCorporateCollectionViewCell", forIndexPath: indexPath) as! JTMCorporateCollectionViewCell
        cell.setDataToCell(corporateListData![indexPath.row])
        cellSize = CGSizeMake((cell.imageCorporate?.imageWidthConstraint?.constant)!, (cell.imageCorporate?.imageWidthConstraint?.constant)!)
        return cell
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        return corporateCollection!.dynamicSize
    }
    
    
    override func layoutSubviews() {
        super.layoutSubviews()
        print("layout to subview")
    }

}

protocol JTMCorporateViewDelagate {
    func onCorporateClick(coporateView : JTMCorporateView, corporateItem : CorporateModel)
}

