//
//  JTMCustomLaunchScreenViewController.swift
//  JobThai
//
//  Created by kanya on 2/3/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMCustomLaunchScreenViewController: JTMBaseViewController {
    
    var isInit:Bool = false
    
    var mainteneData : MaintenanceModel?
    
    var reloadMaintenance : Bool = false
    
    override func viewDidLoad() {
        
    }
    
    override func viewWillAppear(animated: Bool) {
        
    }
    
    override func viewWillDisappear(animated: Bool) {
        
    }
    
    override func viewDidAppear(animated: Bool) {
        if reloadMaintenance {
            reloadMaintenance = false
            pushToMainViewController()
        }
    }
    
    //MARK:- Manage Connection Error
    override func onConnectionSuccess() {
        
    }
    
    override func onConnectionError(errorRequestUrl: String?) {
        
    }
    
    override func showLoading() {
        //print("not show loading")
    }
    
    override func hideLoading() {
        //print("not use this feature")
    }
    
    func pushToMainViewController() {
        if(!isInit){
            connectServiceMaintenance({ (data) -> Void in
                if let mainteneItem = data {
                    self.presentMaintenaceViewController(mainteneItem)
                }
            })
            self.isInit = true
        }
    }

    override func showAlertNoNetworkIsReachable() {
        
    }
    
    override func showAlertWithData(title: String, message: String?, completionHandler: ((UIAlertAction) -> Void)?, actionList: [UIAlertAction]?) {
      
    }
    
    //MARK: Connect Service Maintenance
    func connectServiceMaintenance(completion : ((MaintenanceModel?)->Void)? ){
        let serviceController = JTMServiceController()
        let url = getServiceMaintenance()
        
        serviceController.requestService(self, urlString: url, params: nil, isCanLoadParallelToOther: true) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                let jsonObject = response!.result.value as? NSMutableDictionary
                self.convertMainteneToJson(jsonObject!)
            } else if (status == .CONNECTION_FAIL) {
                self.mainteneData = self.mainteneData ?? MaintenanceModel(type: MaintenanceType.MODE_CONNECTION_FAIL)
            } else {
                self.mainteneData = self.mainteneData ?? MaintenanceModel(type: MaintenanceType.MODE_NO_INTERNET)
            }
            completion?(self.mainteneData)
        }
    }
    
    func convertMainteneToJson(jsonObject : NSMutableDictionary){
        self.mainteneData = self.convertMaintene(jsonObject)
    }
    
    func convertMaintene(mainteneJson : NSMutableDictionary) -> MaintenanceModel{
        return MaintenanceModel(jsonObject: mainteneJson)
    }
    
    //MARK: Present Maintenance
    func presentMaintenaceViewController(data : MaintenanceModel) {
        let maintenanceViewController = self.storyboard?.instantiateViewControllerWithIdentifier("JTMMaintenaceViewController") as? JTMMaintenaceViewController
        maintenanceViewController?.parent = self
        maintenanceViewController?.setMaintenanceData(data)
        applicationDelegate.window?.rootViewController?.presentViewController(maintenanceViewController!, animated: false, completion: nil)

    }
    

}
