//
//  JTMCustomMHGalleryController.swift
//  JobThai
//
//  Created by kanya on 3/22/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

class JTMCustomMHGalleryController: MHGalleryController, MHGalleryDelegate {

    override func viewDidLoad() {
        super.viewDidLoad()
    }

    override init(presentationStyle: MHGalleryViewMode) {
        super.init(nibName: nil, bundle: nil)
        
        self.autoplayVideos = false
        self.preferredStatusBarStyleMH = .Default
        self.presentationStyle = presentationStyle;
        self.transitionCustomization = MHTransitionCustomization()
        self.UICustomization = MHUICustomization()
        
        self.overViewViewController = MHOverviewController()
        self.imageViewerViewController = JTMCustomMHGalleryImageViewerViewController()
        self.galleryDelegate = self
    
        if (presentationStyle != .OverView) {
            self.viewControllers = [self.overViewViewController, self.imageViewerViewController]
        }else{
            self.viewControllers = [self.overViewViewController]
        }
    }

    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    
    //MARK:- Controller Delegate
    func customizeableToolBarItems(toolBarItems: [MHBarButtonItem]!, forGalleryItem galleryItem: MHGalleryItem!) -> [MHBarButtonItem]! {
        
        let imageViewerViewController = self.imageViewerViewController as! JTMCustomMHGalleryImageViewerViewController
        
        var newToolBarItems = toolBarItems
        
        imageViewerViewController.shareButton = MHBarButtonItem(barButtonSystemItem: .Action, target: imageViewerViewController, action: Selector("onPressShare"))
        imageViewerViewController.shareButton!.type = .Share
        
        newToolBarItems[0] = imageViewerViewController.shareButton!
        
        return newToolBarItems
    }
}
