//
//  JTMCustomMHGalleryImageViewerViewController.swift
//  JobThai
//
//  Created by kanya on 3/22/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

class JTMCustomMHGalleryImageViewerViewController: MHGalleryImageViewerViewController {
    
    //Custom share button :: init in delegate (in JTMCustomMHGalleryController)
    var shareButton: MHBarButtonItem?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        let doneButtonTitle = applicationDelegate.getLocalizeStringForKey("DISMISS_WITH_DONE")
        let doneBarButton =  UIBarButtonItem(title: doneButtonTitle, style: .Plain, target: self, action: Selector("donePressed"))
        self.navigationItem.rightBarButtonItem = doneBarButton
    }

    //On select shate button in toolbar :: override from "sharePressed" in MHGalleryImageViewerViewController
    func onPressShare() {
        if (self.UICustomization.showMHShareViewInsteadOfActivityViewController) {
            let share = MHShareViewController()
            share.pageIndex = self.pageIndex
            share.galleryItems = self.galleryItems
            self.navigationController?.pushViewController(share, animated: true)
        }else{
            let imageViewController = self.pageViewController.viewControllers![0] as! MHImageViewController
            
            if (imageViewController.imageView.image != nil) {
                let activityController = UIActivityViewController(activityItems: [imageViewController.imageView.image!], applicationActivities: nil)
                
                activityController.completionWithItemsHandler = {(activityType, isDone, object, error) -> Void in
                    
                    var alertTitle = ""
                    var alertMessage = ""
                    
                    if (activityType != nil) && (activityType! == "com.apple.UIKit.activity.SaveToCameraRoll") {
                        if isDone {
                            alertTitle = applicationDelegate.getLocalizeStringForKey("ALERT_SAVE_PHOTO_SUCCESS")
                            alertMessage = applicationDelegate.getLocalizeStringForKey("ALERT_SAVE_PHOTO_SUCCESS_MESSAGE")
                        } else {
                            alertTitle = applicationDelegate.getLocalizeStringForKey("ALERT_SAVE_PHOTO_FAIL")
                            alertMessage = applicationDelegate.getLocalizeStringForKey("ALERT_SAVE_PHOTO_FAIL_MESSAGE")
                        }
                        
                        self.showAlertController(alertTitle, message: alertMessage)
                    }
                }
            
                self.presentViewController(activityController, animated: true, completion: nil)
                
                if (activityController.respondsToSelector(Selector("popoverPresentationController"))) {
                    activityController.popoverPresentationController?.barButtonItem = shareButton
                }
            }
        }
    }
    
    func showAlertController(title: String, message: String) {
        let alert = UIAlertController(title: title, message: message, preferredStyle: .Alert)
        let okAction = UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("OK"), style: .Default, handler: nil)
        alert.addAction(okAction)
        
        self.presentViewController(alert, animated: true, completion: nil)
    }
}
