//
//  JTMFirstLevelLargeCollectionViewCell.swift
//  JobThai
//
//  Created by Isaret Selachun on 20/1/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

class JTMFirstLevelLargeCollectionViewCell: UICollectionViewCell {
    @IBOutlet weak var titleLabel:UILabel?
    @IBOutlet weak var positionLabel:UILabel?
    @IBOutlet weak var unitLabel:UILabel?
    @IBOutlet weak var imageView:UIImageView?
    
    var selectedStateColor =  JTM_CORE_ORANGE
    var normalStateColor = JTM_SELECTED_CELL_BORDER_COLOR
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        self.layer.borderWidth = 1
        self.layer.cornerRadius = 8
        positionLabel?.textColor    = selectedStateColor
    }

    func setCellData(item : FirstLevelModel){
        self.titleLabel?.text = item.name
        self.positionLabel?.text = item.countPosition?.asNumberFormat
        self.unitLabel?.text = applicationDelegate.getLocalizeStringForKey("JOB_UNIT")
        self.imageView?.sd_setImageWithURL(NSURL(string: item.imageUrl!)!, placeholderImage: UIImage())
//        self.imageView?.af_setImageWithURL(NSURL(string: item.imageUrl!)!)
    }
    
    func setHighlightCell(enable : Bool) {
        if(enable) {
            self.layer.borderColor = selectedStateColor.CGColor
            titleLabel?.textColor = selectedStateColor
            unitLabel?.textColor = selectedStateColor
        } else {
            self.layer.borderColor = normalStateColor.CGColor
            titleLabel?.textColor = UIColor.blackColor()
            unitLabel?.textColor = UIColor.blackColor()
        }
    }
    
}
