//
//  JTMHomeViewController.swift
//  JobThai
//
//  Created by ForAlL on 1/12/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
//import AlamofireImage
import Alamofire
import MHVideoPhotoGallery
//import Firebase
//import GoogleMobileAds

class JTMHomeViewController: JTMBaseMenuViewController,JTMLandingPageViewDelagate, JTMCorporateViewDelagate, JTMBrowseJobHomeViewDelagate, JTMHotJobsViewDelagate , JTMUrgentJobsViewDelegate{

    var webView : JTMWebViewController?
    var refreshControl : UIRefreshControl!
    var jobDetail : JTMJobDetailViewController?
    let ADS_USERDEFAULT_KEY = "ADS_USERDEFAULT_KEY"
    
    @IBOutlet var corporateView : JTMCorporateView?
    @IBOutlet weak var scrollView : UIScrollView!
    @IBOutlet var browseJobsView : JTMBrowseJobsHomeView?
    @IBOutlet var hotJobsView : JTMHotJobsView?
    @IBOutlet weak var landingPage : JTMLandingPageView?
    @IBOutlet var urgentJobsView : JTMUrgentJobsView?
//    @IBOutlet weak var landingPageHeight: NSLayoutConstraint!
    
    var homeObject : HomeModel?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let image = UIImage(named: "ic_home_title")
        let titleImageView = UIImageView(image: image)
        titleImageView.frame = CGRectMake(0, 0, 100, 40)
        navigationItem.titleView = titleImageView//UIImageView(image: image)
        
        initRefreshControl()
        
        // Example Call Service
        connectService()
        
        //showalert();
        setAccessibilityId()
        
        //set Ads
        setAds()
    }
    
    override func setControllerFlags() {
        isNeedToDimOnConnectionError = true
    }
    
    func setAds() {
        // user newly install app
        if NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY) == nil {
            NSUserDefaults.standardUserDefaults().setValue(true, forKey: ADS_USERDEFAULT_KEY)
            print("==== APP OPEN FOR THE FIRST TIME ====")
            print("==== APP ADS IS SET TO \(NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY))")
        }
        else {
            print("==== APP ADS IS CURRENTLY SET TO \(NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY))")
        }
    }
    
    func setAccessibilityId(){
        self.view.accessibilityIdentifier = ID_HOME_VIEW
    }
    
    func showalert() {
        self.showAlertWithData(applicationDelegate.getLocalizeStringForKey("AlertTestTitle"), message: applicationDelegate.getLocalizeStringForKey("AlertTest"), completionHandler: nil, actionList: nil)
    }
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        browseJobsView?.startTimer()
        landingPage?.startTimer()
        
        print("Home : viewDidAppear")
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_HOME)
        
        self.scrollView.contentSize.height = (self.landingPage?.frame.height)! + (self.corporateView?.frame.height)! + (self.browseJobsView?.frame.height)! + (self.hotJobsView?.frame.height)! + (self.urgentJobsView?.frame.height)!
    }
    
    override func viewDidDisappear(animated: Bool) {
        super.viewDidDisappear(animated)
        browseJobsView?.stopTimer()
        landingPage?.stopTimer()
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    override func onRetryConnection() {
        super.onRetryConnection()
//        connectService()
        if !(isLoadingService) && (homeObject == nil) {
            connectService()
        }
    }

    //MARK:- Manage View on Error
    override func manageViewOnError(view: UIView) {
        super.manageViewOnError(view)
        if (homeObject == nil) {
            setAlphaShowToView(view)
        }
    }
    
    func initRefreshControl(){
        self.refreshControl = UIRefreshControl()
        //self.refreshControl?.attributedTitle = NSAttributedString(string: "Pull to refresh")
        self.refreshControl.addTarget(self, action: #selector(handleRefreshControl) , forControlEvents: UIControlEvents.ValueChanged)
        self.refreshControl.tintColor = self.navigationController?.navigationBar.barTintColor
        self.scrollView.addSubview(self.refreshControl)
    }
    
    func handleRefreshControl(){
        refreshControl.endRefreshing();
        if(self.isLoadingService == false ){
            connectService()
        }
    }
    
    //Call Service JSON Function
    func connectService(){
        let serviceController = JTMServiceController()
        let url = getServiceAppHome()
        
        serviceController.requestService(self, urlString: url, params: nil) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                let jsonObject = response!.result.value as? NSMutableDictionary
                self.convertJsonToModel(jsonObject!)
                self.createSubViewHome()
            }
        }
    }
    
    func convertJsonToModel(jsonAppHome : NSMutableDictionary) {
        homeObject = HomeModel(jsonObject: jsonAppHome)
    }
    
    //subview
    func createSubViewHome(){
        createViewLandingPage();
        createViewCorporate()
        createViewBrowseJobs()
        createViewHotJobs()
        createViewUrgentJobs()
    }
    
    //Landing Page
    func createViewLandingPage() {
        landingPage?.delegate = self
        guard let landingPageList = homeObject?.landingPageList where landingPageList.count > 0 else {
            return
        }
        landingPage?.setLandingPageModel(landingPageList)
    }
    
    func onLandingPageClick(landingPageView: JTMLandingPageView, landingPageItem: LandingPageModel) {
        
        var comValue : String?
        
        if landingPageItem.type != .WEBVIEW {
            comValue = landingPageItem.companyCode
            self.openJobDetail(landingPageItem.companyCode!, jobcode: landingPageItem.jobCode!, type: landingPageItem.type!)
        } else {
            comValue = landingPageItem.companyName
            self.opeWebView(landingPageItem.companyName!, linkUrl: landingPageItem.linkUrl!)
        }
        
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_LANDING_PAGE, action: ACTION_CLICK, label: getLabelLandingPageWithComCode(comValue!))
    }
    
    func opeWebView(title : String , linkUrl : String) {
        webView = self.storyboard?.instantiateViewControllerWithIdentifier("JTMWebViewController") as? JTMWebViewController
        webView?.webTitle = title
        webView?.urlString = linkUrl
        
        // Track Google Analytic Screen
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_BANNER)
        
        self.navigationController?.pushViewController(webView!, animated: true)
    }
    
    func openJobDetail(companyCode : String, jobcode : Int, type : IndexJobDetailPage) {
        let jobDetailStoryBoard = UIStoryboard(name: "JobDetail", bundle: nil)
        let jobDetail = jobDetailStoryBoard.instantiateViewControllerWithIdentifier("JTMJobDetailViewController") as? JTMJobDetailViewController
        
        jobDetail?.companyCode = companyCode
        if type == .JOB_INFO_PAGE {
            jobDetail?.jobCode = jobcode
        }
        jobDetail?.openPageType = type
        
        self.navigationController?.pushViewController(jobDetail!, animated: true)
    }
    
    //corporate
    func createViewCorporate() {
        corporateView?.delegate = self
        corporateView?.setModelCorporate((homeObject?.corporateList)!)
    }
    
    //corporate delegate
    func onCorporateClick(coporateView: JTMCorporateView, corporateItem: CorporateModel) {
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_CORPORATE_PAGE)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_CORPORATE_PAGE, action: ACTION_CLICK, label: getLabelCorporatePageWithComCode(corporateItem.companyCode!))
        
        // Open Jobdetail All Position
        self.onOpenJobDetail(corporateItem.companyCode!, type: .ALL_POSITION_PAGE)
    }
    
    //browsejob
    func createViewBrowseJobs() {
        browseJobsView!.delegate = self
        browseJobsView?.setRegionModel((homeObject?.browseJobsHomeObject)!)
    }
    
    
    //browsejob delegate
    func onBrowseJobsHomeClick() {
        JTMBrowseJobViewController.openBrowseJobViewController(self.storyboard!, navigationController: self.navigationController!, type: typeBrowseJob.HOME, code: nil, searchParams: nil)
    }
    
    // hotjobs 
    func createViewHotJobs() {
        hotJobsView?.delegate = self
        hotJobsView?.setModelHotJobs((homeObject?.hotJobsList)!)
    }
    
    func onHotClick(hotJobsView: JTMHotJobsView, hotJobsItem: HotJobsModel) {
        
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_HOT_JOBS, action: ACTION_CLICK, label: getLabelHotJobWithComCode(hotJobsItem.companyCode!))
        
        
        // Open Jobdetail All Position
        self.onOpenJobDetail( hotJobsItem.companyCode!, type: .ALL_POSITION_PAGE)
    }
    
    //MARK : UrgentJobs
    func createViewUrgentJobs(){
        urgentJobsView?.delegate = self
        urgentJobsView?.setUrgentJobsData(homeObject!.urgenJobstList!)
    }
    
    func urgentJobsDidSelect(urgentJobsView: JTMUrgentJobsView, item: UrgentJobsModel) {
        
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_URGENT_JOBS, action: ACTION_CLICK, label: getLabelUrgentJobWithComCode(item.companyCode!))
        
        // Open Jobdetail All Position
        self.onOpenJobDetail( item.companyCode!, type: .ALL_POSITION_PAGE)

    }
    
    func onOpenJobDetail(companyCode : String , type : IndexJobDetailPage) {
        jobDetail = self.storyboard?.instantiateViewControllerWithIdentifier("JTMJobDetailViewController") as? JTMJobDetailViewController
        jobDetail?.companyCode = companyCode
        jobDetail?.openPageType = type
        self.navigationController?.pushViewController(jobDetail!, animated: true)
    }
    
    func onBrowseJobsRegionTableClick(regionTableView: UITableView, regionItem: BrowseJobHomeRegionsModel) {
        print(regionItem.type)
        
        switch (regionItem.type!) {
            
        case .FIRST_LEVEL:
            self.goToFirstLevelBrowseJobs(regionItem)
            break
            
        case .SECOND_LEVEL:
            self.goToSecondLevelBrowseJobs(regionItem)
            break

        case .SEARCH_RESULT:
            self.goToSearchResult(regionItem)
            break
            
        default:
            break
        }
    }
    
    func goToFirstLevelBrowseJobs(regionItem:BrowseJobHomeRegionsModel) {
        //self.mockUpViewControllerWithShowLabel("First level for \(regionItem.code!)")
        JTMBrowseJobViewController.openBrowseJobViewController(self.storyboard!, navigationController: self.navigationController!, type: typeBrowseJob.FIRST_LEVEL, code: regionItem.code, searchParams: nil, title:regionItem.getTilte((applicationDelegate.appSetting?.currentLanguage)!), searchMode:.INDUSTRIAL)
    }
    
    func goToSecondLevelBrowseJobs(regionItem:BrowseJobHomeRegionsModel) {
        //self.mockUpViewControllerWithShowLabel("Second level for \(regionItem.code!)")
        JTMBrowseJobViewController.openBrowseJobViewController(self.storyboard!, navigationController: self.navigationController!, type: typeBrowseJob.SECOND_LEVEL, code: regionItem.code, searchParams: nil, title:regionItem.getTilte((applicationDelegate.appSetting?.currentLanguage)!), searchMode:.LOCATION)
    }
    
    func goToSearchResult(regionItem:BrowseJobHomeRegionsModel) {
        //self.mockUpViewControllerWithShowLabel("Search result for \(regionItem.code!)")
        let param = [
            PARAMETER_JOB_TYPE_KEY      : DEFAULT_PARAMETER,
            PARAMETER_SUB_JOB_TYPE_KEY  : DEFAULT_PARAMETER,
            PARAMETER_LOCATION_KEY      : regionItem.code!
        ]
        
        //PARAMETER_DEFAULT + PARAMETER_LOCATION + regionItem.code!
        JTMBrowseJobViewController.openBrowseJobViewController(self.storyboard!, navigationController: self.navigationController!, type: typeBrowseJob.SEARCH_RESULT, code: regionItem.code, searchParams: param, title:regionItem.getTilte((applicationDelegate.appSetting?.currentLanguage)!))
    }
    
    //language change
    override func onLanguageChange() {
        super.onLanguageChange()
        browseJobsView?.reloadViewData()
    }
}

