//
//  JTMImageView.swift
//  JobThai
//
//  Created by pinyo on 7/27/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMImageView : UIImageView {
    
    @IBOutlet var imageWidthConstraint  : NSLayoutConstraint?
    @IBOutlet var imageHeightConstraint : NSLayoutConstraint?
    
    //Inch Unit of Display Device Size.| Ex. isIphone35 = Iphone Display size 3.5"
    @IBInspectable var iPhone35 : CGSize = CGSizeZero
    @IBInspectable var iPhone4  : CGSize = CGSizeZero
    @IBInspectable var iPhone47 : CGSize = CGSizeZero
    @IBInspectable var iPhone55 : CGSize = CGSizeZero
    @IBInspectable var Default  : CGSize = CGSizeZero
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setUpUi()
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setUpUi()
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        setUpUi()
    }
    
    
    func overrideImageSize(imageSize : CGSize){
        self.imageWidthConstraint?.constant = imageSize.width
        self.imageHeightConstraint?.constant = imageSize.height
        self.layoutIfNeeded()
    }

    func setUpUi() {
        var size : CGSize = CGSizeZero
        
        switch screenType {
        case .SCREEN_3_5_INCH :
            size = iPhone35
            break
        case .SCREEN_4_0_INCH :
            size = iPhone4
            break
        case .SCREEN_4_7_INCH :
            size = iPhone47
            break
        case .SCREEN_5_5_INCH :
            size = iPhone55
            break
        default :
            size = Default
            break
        }
        
        overrideImageSize(size)
    }
}
