//
//  JTMJobDetailAllPosition.swift
//  JobThai
//
//  Created by weerapon on 3/15/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailAllPositionViewController : JTMBaseViewController, UICollectionViewDataSource, UICollectionViewDelegate , UIScrollViewDelegate, UICollectionViewDelegateFlowLayout {
    
    let PAGE_INDEX: IndexJobDetailPage = .ALL_POSITION_PAGE
    let OPEN_JOBDETAIL_PAGE = 0
    let PIXEL_OF_HIDDEN_HEADER : CGFloat = 5
    let MARGIN_LEFT_RIGHT_WIDTH : CGFloat = 4
    let HEIGHT_CELL : CGFloat = 150
    let CELL_BETWEEN_PADDONG : CGFloat = 0
    
    let ALL_POSITION_CELL_IDENTIFIER = "JTMJobdetailAllPositionCollectionViewCell"
    
    var listAllPosition = [PositionModel]()
    var checkOnScrolling = false
    var stopOnScrollingWhenOpenView = true
    var delegateOnScroll : JTMJobDetailMainForSubPageViewDelegate?
    var delegateOnClick : JTMClickAllPositionDelegate?
    
    var containerViewController : JTMJobDetailViewController?
    var jobdetailPageViewController : JTMJobDetailPageViewController?
    
    @IBOutlet weak var collectionViewAllPosition : UICollectionView?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.registerNibFile()
//        self.initialUI(true)
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        
        print("JobDetailAllPosition  viewWillAppear")
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_JOB_DETAIL_ALL_POSITION)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_ALL_POSITION, action: ACTION_VIEW, label: LABEL_VIEW_ALL_POSITION)
        
        // Mark :: Reset onScrolling
        checkOnScrolling = false
        
        // Mark :: Reload Collection View
        if (listAllPosition.count != 0 && isPresentedBefore) {
//            collectionViewAllPosition?.setContentOffset(CGPoint(x: 0, y: 0), animated: false)
//            self.view.layoutIfNeeded()
            
            UIView.animateWithDuration(0) {
                self.collectionViewAllPosition?.setContentOffset(CGPoint(x: 0, y: 0), animated: false)
                self.view.layoutIfNeeded()
            }
        }
    }
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
    }
    
    override func setControllerFlags() {
        //Need to set flag before call super cause we need it set as true before initnointernetview
        isPresentedInOtherController = true
    }
    
    override func setPresentedBeforeFlag() {
        super.setPresentedBeforeFlag()
        
        // Mark :: Reload Collection View
        if (listAllPosition.count != 0) {
            self.performSelector(#selector(reloadDataOnFirstTime), withObject: self, afterDelay: 0.1)
        } else if (self.jobdetailPageViewController?.isLoadingService == false) {
            self.containerViewController?.hideLoading()
        }
    }
    
    func reloadDataOnFirstTime() {
        self.collectionViewAllPosition?.reloadData()
        self.containerViewController?.hideLoading()
    }
    
    // Mark :: Register Nib File
    func registerNibFile() {
        let nib = UINib(nibName: ALL_POSITION_CELL_IDENTIFIER, bundle: nil)
        collectionViewAllPosition?.registerNib(nib, forCellWithReuseIdentifier: ALL_POSITION_CELL_IDENTIFIER)
    }
    
    // Mark :: Update Data After Load Service
    func updateData(listAllPosition : [PositionModel]) {
        
        self.listAllPosition = listAllPosition
        
        if (isPresentedBefore) {
            self.collectionViewAllPosition?.reloadData()
//            collectionViewAllPosition?.setContentOffset(CGPoint(x: 0, y: 0), animated: false)
//            self.view.layoutIfNeeded()
            UIView.animateWithDuration(0) {
                self.collectionViewAllPosition?.setContentOffset(CGPoint(x: 0, y: 0), animated: false)
                self.view.layoutIfNeeded()
            }
        }
    }
    
    // Mark :: Delegate FloawLayout Set Width and Height Cell
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
//        return CGSize(width: collectionView.frame.width - DEFAULT_CELL_MARGIN, height: self.HEIGHT_CELL)
        let cellWidth = collectionView.frame.width
        return collectionView.ar_sizeForCellWithIdentifier(ALL_POSITION_CELL_IDENTIFIER, indexPath: indexPath, fixedWidth: cellWidth, configuration: { (cellItem) in
            if let cell = cellItem as? JTMJobdetailAllPositionCollectionViewCell {
                cell.setDataCell(self.listAllPosition[indexPath.row], sequence: indexPath.row + 1)
            }
        })
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
        return CELL_BETWEEN_PADDONG
    }
    
    
    
    // Mark :: Delegate CollectionView Event Click
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticEvent(CAT_ALL_POSITION, action: ACTION_CLICK, label: LABEL_JOB_DETAIL)
        let oldSelected = self.jobdetailPageViewController?.selectedJob
        self.delegateOnClick?.onClickItemAllPosition(self.OPEN_JOBDETAIL_PAGE, indexList: indexPath.row ,jobcode: self.listAllPosition[indexPath.row].runningNumber!)
        collectionView.reloadItemsAtIndexPaths([NSIndexPath(forRow: oldSelected!, inSection: 0)])
    }
    
    func displaySignUpPendingAlert() -> UIAlertController {
        //create an alert controller
        let pending = UIAlertController(title: "Creating New User", message: nil, preferredStyle: .Alert)
        
        //create an activity indicator
        let indicator = UIActivityIndicatorView(frame: pending.view.bounds)
        indicator.autoresizingMask = [.FlexibleWidth, .FlexibleHeight]
        
        //add the activity indicator as a subview of the alert controller's view
        pending.view.addSubview(indicator)
        indicator.userInteractionEnabled = false // required otherwise if there buttons in the UIAlertController you will not be able to press them
        indicator.startAnimating()
        
        self.presentViewController(pending, animated: true, completion: nil)
        
        return pending
    }
    
    func collectionView(collectionView: UICollectionView, didHighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMJobdetailAllPositionCollectionViewCell
        cell?.backgroundColor = JTM_HIGHLIGHT_COLOR
    }
    
    func collectionView(collectionView: UICollectionView, didUnhighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMJobdetailAllPositionCollectionViewCell
        cell?.backgroundColor = UIColor.clearColor()
    }
    
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return isPresentedBefore ? 1 : 0
    }
    
    // Mark :: Delegate CollectionView Number Of Items In Section
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        print("numberOfItemsInSection  :: \(self.listAllPosition.count)")
        return self.listAllPosition.count
    }
    
    // Mark :: Delegate CollectionView Set Cell in Collection
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier(ALL_POSITION_CELL_IDENTIFIER, forIndexPath: indexPath) as? JTMJobdetailAllPositionCollectionViewCell
        cell?.setDataCell(listAllPosition[indexPath.row], sequence: indexPath.row + 1)
        
//        if ((self.jobdetailPageViewController?.selectedJob == nil) && (indexPath.row == 0))
//            || (indexPath.row == self.jobdetailPageViewController?.selectedJob) {
//            cell?.selected = true
//        }
        
        return cell!
    }
    
    // Mark :: Delegate onScroll To hidden and show Company Title
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let offset : CGPoint = scrollView.contentOffset;
        
        if(offset.y > self.PIXEL_OF_HIDDEN_HEADER && !checkOnScrolling){
            self.checkOnScrolling = true
            dispatch_async(dispatch_get_main_queue()) {
                self.delegateOnScroll?.onScrollView(true ,index: self.PAGE_INDEX.rawValue)
            }
        } else if(offset.y < self.PIXEL_OF_HIDDEN_HEADER && (!isCollectionViewCantScrollToBottom() || (isCollectionViewCantScrollToBottom() && scrollView.isScrollUp(scrollView)))) {
            self.checkOnScrolling = false
            dispatch_async(dispatch_get_main_queue()) {
                self.delegateOnScroll?.onScrollView(false ,index: self.PAGE_INDEX.rawValue)
            }
        }
    }
    
    func isCollectionViewCantScrollToBottom() -> Bool {
        let collectionViewHeight = collectionViewAllPosition?.contentSize.height
        let companyHeaderHeight = containerViewController?.headerStackView?.frame.height
        let segmentHeight = containerViewController?.segmentContainerView.frame.height
        let isCollectionViewHigherThanViewWithHideCompanyHeader = collectionViewHeight <= DEFAULT_FRAME_HEIGHT - segmentHeight!
        let isCollectionViewShorterThanViewWithShowCompanyHeader = collectionViewHeight >= DEFAULT_FRAME_HEIGHT - segmentHeight! - companyHeaderHeight!
        
        return isCollectionViewHigherThanViewWithHideCompanyHeader && isCollectionViewShorterThanViewWithShowCompanyHeader
    }
}