//
//  JTMJobDetailHowToApplyTableViewCell.swift
//  JobThai
//
//  Created by kanya on 5/25/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailHowToApplyTableViewCell: UITableViewCell {

    @IBOutlet weak var titleLabel: JTMLabel!
    @IBOutlet weak var descriptionTextView: JTMTextView!
    @IBOutlet weak var englishOnlyLabel: JTMLabel!
    
    override func awakeFromNib() {
        super.awakeFromNib()
    }
    
    func setCellData(infoForCell: JobInfoModel) {
        self.titleLabel.text = infoForCell.title
        let howToApplyData = JTMJobDetailHowToApplyTableViewCell.getHowToApplyFromCellData(infoForCell.valueInfo!)
        
        descriptionTextView.text = howToApplyData[0]
        self.descriptionTextView.dataDetectorTypes = .None
        descriptionTextView.hidden = (howToApplyData[0] == "")
        
        englishOnlyLabel.text = howToApplyData[1]
        englishOnlyLabel.hidden = (howToApplyData[1] == "")
    }
    
    static func getHowToApplyFromCellData(cellData: String) -> [String] {
        var howToApplyDataList = cellData.componentsSeparatedByString("ENGLISHONLY:")
        var i = 0
        
        for data in howToApplyDataList {
            howToApplyDataList[i] = data.stringByTrimmingCharactersInSet(.whitespaceAndNewlineCharacterSet())
            i += 1
        }
        
        return howToApplyDataList
    }
}
