//
//  JTMJobDetailTextTableViewCell.swift
//  JobThai
//
//  Created by kanya on 3/30/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailTextTableViewCell: UITableViewCell {

    @IBOutlet weak var titleLabel: JTMLabel!
    @IBOutlet weak var descriptionTextView: JTMTextView!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        initSelectedBackground()
    }
    
    //MARK:- Set Cell
    func setCellData(jobInfoForCell: JobInfoModel, isDetectForLink: Bool) {
        setCellTitleLabel(jobInfoForCell.title!)
        setCellDescriptionTextView(jobInfoForCell.valueInfo!, isDetectForLink: isDetectForLink)
    }
    
    func setCellData(jobInfoForCell: CompanyInfoTextModel, isDetectForLink: Bool) {
        setCellTitleLabel(jobInfoForCell.title!)
        setCellDescriptionTextView(jobInfoForCell.valueInfo!, isDetectForLink: isDetectForLink)
    }
    
    func setCellTitleLabel(title: String) {
        self.titleLabel.text = title
    }
    
    func setCellDescriptionTextView(description: String, isDetectForLink: Bool) {
        self.descriptionTextView.text = description
        self.descriptionTextView.dataDetectorTypes = isDetectForLink ? [.PhoneNumber, .Link] : .None
    }

    override func setSelected(selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
    //MARK:- Selected background
    func initSelectedBackground() {
        let selectedBackgroundView = UIView(frame: CGRectZero)
        self.selectedBackgroundView = selectedBackgroundView
    }

}
