//
//  JTMJobdetailAllPositionCollectionViewCell.swift
//  JobThai
//
//  Created by weerapon on 3/28/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobdetailAllPositionCollectionViewCell : UICollectionViewCell {
    
    @IBOutlet weak var sequence : JTMLabel?
    @IBOutlet weak var dateJob : JTMLabel?
    @IBOutlet weak var positionJob : JTMLabel?
    @IBOutlet weak var descriptionJob : JTMLabel?
    @IBOutlet weak var country : JTMLabel?
    @IBOutlet weak var salary : JTMLabel?
    @IBOutlet weak var salaryImg: UIImageView!
    @IBOutlet weak var saralyHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var topBorderView: UIView!
    @IBOutlet weak var bottomBorderView: UIView!
    @IBOutlet weak var topBorderHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var bottomBorderHeightConstraint: NSLayoutConstraint!
    
    let SELECTED_BODER_WIDTH: CGFloat = 2.5
    let BORDER_WIDTH: CGFloat = JTM_CELL_BORDER_HEIGHT//2
    let BORDER_COLOR : UIColor = JTM_CELL_SEPERATOR_COLOR//UIColor(hexString: "#F1F2F2")
    let SELECTED_BG_COLOR = JTM_HIGHLIGHT_COLOR
    let SALARY_FIELD_HEIGHT : CGFloat = 20

    func setDataCell(itemJob : PositionModel, sequence : Int) {
        self.sequence?.text = "\(sequence)"
        self.topBorderHeightConstraint.constant = (sequence == 1) ? BORDER_WIDTH : 0
        self.dateJob?.text = itemJob.date
        self.positionJob?.text = itemJob.jobTitle
        self.descriptionJob?.text = itemJob.jobDescription
        self.country?.text = (itemJob.countryCode == "TH") ? itemJob.provinceName : itemJob.national
        
        self.salary?.text = itemJob.salary
        self.salary?.hidden = (itemJob.salary == "")
        self.salaryImg.hidden = (itemJob.salary == "")
        self.saralyHeightConstraint.constant = (itemJob.salary == "") ? 0 : SALARY_FIELD_HEIGHT
    }
    
    override func awakeFromNib() {
//        setSelectedCell()
        setCellBorder()
    }
    
    func setSelectedCell() {
//        let view = UIView(frame: CGRectMake(0, 0, self.frame.width, self.frame.height))
//        view.layer.borderWidth = SELECTED_BODER_WIDTH
//        view.layer.borderColor = BORDER_COLOR.CGColor
//        self.selectedBackgroundView = view
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = SELECTED_BG_COLOR
        
        self.selectedBackgroundView = backgroundView
    }
    
    func setCellBorder() {
//        self.layer.borderColor = UIColor(hexString: "#CCCCCC").CGColor
//        self.layer.borderWidth = BORDER_WIDTH
        
        //top border
        self.topBorderView.backgroundColor = BORDER_COLOR
        self.topBorderHeightConstraint.constant = BORDER_WIDTH
        //set bottom border
        self.bottomBorderView.backgroundColor = BORDER_COLOR
        self.bottomBorderHeightConstraint.constant = BORDER_WIDTH
    }
    
}