//
//  JTMLabel.swift
//  JobThai
//
//  Created by tayathorn on 7/22/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

class JTMLabel : UILabel {
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }
    
    @IBInspectable var iPhone35FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_3_5_INCH {
                overrideFontSize(iPhone35FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone4FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_4_0_INCH {
                overrideFontSize(iPhone4FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone47FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_4_7_INCH {
                overrideFontSize(iPhone47FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone55FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_5_5_INCH {
                overrideFontSize(iPhone55FontSize)
            }
        }
    }
    
    @IBInspectable var DefaultFontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_UNKNOWN {
                overrideFontSize(DefaultFontSize)
            }
        }
    }
    
    func overrideFontSize(fontSize:CGFloat){
        let currentFontName = self.font.fontName
        if let calculatedFont = UIFont(name: currentFontName, size: fontSize) {
            self.font = calculatedFont
        }
    }
}