//
//  JTMMainMenuHeaderView.swift
//  JobThai
//
//  Created by kanya on 5/25/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

class JTMMainMenuHeaderView: UIView {
    
    let PROFILE_PLACEHOLDER_IMAGE_NAME = "ic_menu_home"
    let PROFILE_BORDER_WIDTH : CGFloat = 2

    @IBOutlet weak var firstNameLabel: JTMLabel!
    @IBOutlet weak var lastNameLabel: JTMLabel!
    @IBOutlet weak var profileImageView: UIImageView!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.backgroundColor = JTM_MENU_BG_COLOR
    }
    
    func setUserDataToView(userData: UserModel) {
        firstNameLabel.text = userData.firstName
        lastNameLabel.text = userData.lastName
        setUserProfileImage(userData.profilePic!)
    }
    
    func setUserProfileImage(imagePath: String) {
        if let imageUrl = NSURL(string: imagePath) {
            profileImageView.sd_setImageWithURL(imageUrl, placeholderImage: UIImage(named: PROFILE_PLACEHOLDER_IMAGE_NAME))
        } else {
            profileImageView.image = UIImage(named: PROFILE_PLACEHOLDER_IMAGE_NAME)
        }
        
        profileImageView.layer.cornerRadius = profileImageView.frame.width/2
        profileImageView.layer.borderColor = JTM_CORE_ORANGE.CGColor
        profileImageView.layer.borderWidth = PROFILE_BORDER_WIDTH
        profileImageView.clipsToBounds = true
    }
}
