//
//  JTMMainQuickGuideViewController.swift
//  JobThai
//
//  Created by ForAlL on 2/9/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMMainQuickGuideViewController: UIViewController , UIPageViewControllerDataSource {

//    @IBOutlet var pageContentView : UIView?
    @IBOutlet var skipButton : UIButton?
    
    var pageViewController : UIPageViewController?
    var quickGuideImageList : NSMutableArray?//[String]()
    var pageContentList = [ JTMPageContentViewController]()
    var firstScroll : Bool = false
    var languageKey : String?
    
    var maintenanceView : JTMMaintenaceViewController?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        initImageList()
        setLanguageKey()
        self.pageContentList = [self.viewControllerAtIndex(0)!]//, self.viewControllerAtIndex(1),self.viewControllerAtIndex(2),self.viewControllerAtIndex(3),self.viewControllerAtIndex(4)]
        self.skipButton?.setTitle(applicationDelegate.getLocalizeStringForKey("QUICK_GUIDE_SKIP"), forState: .Normal)
        self.initialPageControl()
        
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    func initImageList() {
        if let path = NSBundle.mainBundle().pathForResource("ListQuickGuide", ofType: "plist") {
            quickGuideImageList = NSMutableArray(contentsOfFile: path)!
        }
    }
    
    func setLanguageKey() {
        languageKey = (applicationDelegate.appSetting?.currentLanguage == .THAI) ? "nameTH" : "nameEN"
    }
   
    func initialPageControl(){
        
        //Setup PageControl Style
        let pageControl = UIPageControl.appearance()
//        pageControl.pageIndicatorTintColor = UIColor(colorLiteralRed: 1, green: 1, blue: 1, alpha: 0.6)
        pageControl.pageIndicatorTintColor = UIColor(hexString: "#d6d6d6")
//        pageControl.currentPageIndicatorTintColor = UIColor.whiteColor()
        pageControl.currentPageIndicatorTintColor = UIColor(hexString: "#FF5C05")
//        pageControl.backgroundColor = UIColor(hexString: "#FC680F")
        pageControl.backgroundColor = UIColor(hexString: "#FFFFFF")
        pageControl.userInteractionEnabled = false
        
        self.pageViewController = self.storyboard?.instantiateViewControllerWithIdentifier("PageViewController") as? UIPageViewController
        self.pageViewController?.dataSource = self
        self.pageViewController?.setViewControllers(self.pageContentList, direction: UIPageViewControllerNavigationDirection.Forward, animated: false, completion: nil)
        
        self.addChildViewController(self.pageViewController!)
        self.view.addSubview((self.pageViewController?.view)!)
        self.view.sendSubviewToBack((self.pageViewController?.view)!)
        self.pageViewController?.didMoveToParentViewController(self)
    }
    
    //MARK: PageView DataSource
    func viewControllerAtIndex(index : Int)->JTMPageContentViewController?{
        if(self.quickGuideImageList?.count == 0 || index >= self.quickGuideImageList?.count){
            print("Cannot create View at index : \(index)")
            return nil
        }
        
        let pageContent = UINib(nibName: "JTMPageContentViewController", bundle: nil).instantiateWithOwner(self, options: nil)[0] as? JTMPageContentViewController
        pageContent?.setData(index, fileName: quickGuideImageList?[index].objectForKey(languageKey) as! String)
        
        return pageContent
        
    }
    
    func setScrollEnable(enabled : Bool, forPageViewController pageViewController : UIPageViewController){
        for view : UIView in pageViewController.view.subviews{
            if view.isKindOfClass(UIScrollView){
                print("Found ScrollView!!")
                let scrollView : UIScrollView = (view as? UIScrollView)!
                scrollView.bounces = enabled
                break
            }
        }
    }
    
    func pageViewController(pageViewController: UIPageViewController, viewControllerBeforeViewController viewController: UIViewController) -> UIViewController? {
        
        var index : NSInteger = (viewController as! JTMPageContentViewController).pageIndex!
//        print("Before : \(index)")
//        if(index == 0){
//            print("BF not scroll")
//            self.setScrollEnable(false, forPageViewController: self.pageViewController!)
//        }
        
        if(index == 0 || index == NSNotFound) {
            return nil
        }
        
        index -= 1
//        self.setScrollEnable(true, forPageViewController: self.pageViewController!)
        return self.viewControllerAtIndex(index)
        
    }
    
    func pageViewController(pageViewController: UIPageViewController, viewControllerAfterViewController viewController: UIViewController) -> UIViewController? {
        var index : NSInteger = (viewController as! JTMPageContentViewController).pageIndex!
//        if(firstScroll == false){
//            print("AF not scroll")
//            firstScroll = true
//            self.setScrollEnable(false, forPageViewController: self.pageViewController!)
//            return nil
//        }
        
        if(index == (self.quickGuideImageList?.count)! - 1) {
//            self.setScrollEnable(false, forPageViewController: self.pageViewController!)
            return nil
        }
        
        index += 1
//        self.setScrollEnable(true, forPageViewController: self.pageViewController!)
        return self.viewControllerAtIndex(index)
    }
    
    func presentationCountForPageViewController(pageViewController: UIPageViewController) -> Int {
        return (self.quickGuideImageList?.count)!
    }
    
    func presentationIndexForPageViewController(pageViewController: UIPageViewController) -> Int {
        let currentView = pageViewController.viewControllers?.first as? JTMPageContentViewController
        return (currentView?.pageIndex)!
    }
    
    //MARK:- SKIP Button Click
    @IBAction func pageContentViewSkipButtonClick() {
        if !NSUserDefaults.standardUserDefaults().boolForKey(HAS_SEEN_QUICK_GUIDE) {
            NSUserDefaults.standardUserDefaults().setBool(true, forKey: HAS_SEEN_QUICK_GUIDE)
            maintenanceView?.presentPreLoad(self)
        } else {
            self.dismissViewControllerAnimated(true, completion: nil)
        }
    }

//    func scroll
}

