//
//  JTMNoNetworkHeaderTabView.swift
//  JobThai
//
//  Created by tayathorn on 5/27/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMNoNetworkHeaderTabView: UIView {
    
    @IBOutlet var noNetworkLabel : JTMLabel!
    
    var view: UIView!
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
        setLabel()
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMNoNetworkHeaderTabView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil).first as! UIView
        return view
    }
    
    func setLabel() {
        self.noNetworkLabel.text = applicationDelegate.getLocalizeStringForKey("NO_NETWORK_REACHABLE_MESSAGE")
    }
}
