//
//  JTMResumeNoResultView.swift
//  JobThai
//
//  Created by tayathorn on 5/13/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMResumeNoResultView: UIView {

    @IBOutlet weak var noResultImage: UIImageView!
    @IBOutlet weak var noResultHeaderLabel: JTMLabel!
    @IBOutlet weak var noResultDescriptionLabel: JTMLabel!
    
    var view : UIView!
    
//    let APPLIED_JOB = "AppliedJob"
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        // Code Here
        setupUI()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        // Code Here
        setupUI()
    }
    
    func setupUI() {
        view = loadViewFromNib()
        view.frame = bounds
//        view.autoresizingMask = [.FlexibleWidth, .FlexibleHeight]
        addSubview(view)
        self.hidden = true
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMResumeNoResultView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        
        return view
    }
    
//    func setNoResultTitle () {
//        self.noResultLabel.text = applicationDelegate.getLocalizeStringForKey("NO_RESULT")
//    }
    
//    func setNoresultValue(type : String) {
//        
//        switch type {
//        case APPLIED_JOB :
//            self.noResultHeaderLabel.text = applicationDelegate.getLocalizeStringForKey("APPLIED_JOB_NO_RESULT")
//            self.noResultDescriptionLabel.hidden = true
//            self.noResultImage.image = UIImage(named: "ic_apply_job")
//            break
//        default :
//            break
//        }
//        
//    }
    
    func setNoResultForAppliedJob() {
        self.noResultHeaderLabel.text = applicationDelegate.getLocalizeStringForKey("APPLIED_JOB_NO_RESULT")
        self.noResultDescriptionLabel.hidden = true
        self.noResultImage.image = UIImage(named: "no_applied_job")
    }
    
    func setNoResult(title : String, isHideDescription : Bool, pathImage : String) {
        self.noResultHeaderLabel.text = title
        self.noResultDescriptionLabel.hidden = isHideDescription
        self.noResultImage.image = UIImage(named: pathImage)
    }
    
    func setNoResultForFavoriteJob() {
        self.noResultHeaderLabel.text = applicationDelegate.getLocalizeStringForKey("FAVORITE_JOB_NO_RESULT")
        self.noResultDescriptionLabel.hidden = true
        self.noResultImage.image = UIImage(named: "no_favorite_job")
    }
    
}
