//
//  JTMSearchFilterTypeTableViewCell.swift
//  JobThai
//
//  Created by ForAlL on 2/26/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchFilterTypeTableViewCell: UITableViewCell {

    @IBOutlet weak var icon: UIImageView?
    @IBOutlet weak var title: JTMLabel?
    @IBOutlet weak var subTitle: JTMLabel?
    @IBOutlet weak var stackView : UIStackView?
    
    let FONT_SIZE_MINI_SCREEN : CGFloat = 16.0
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        updateFontSizeForDevice()
        setSelectedBackgroundView()
    }

//    override func setSelected(selected: Bool, animated: Bool) {
//        super.setSelected(selected, animated: animated)
//
//        // Configure the view for the selected state
//    }
    
    func setMenuSearchFilter(iconName: String, title: String, subTitle: String) {
        self.icon?.image = UIImage(named: iconName)
        self.title?.text = title
        self.subTitle?.attributedText = convertToAttributeString(subTitle)
        
    }
    
    func setIconHighlightedImage(iconName: String) {
        self.icon?.highlightedImage = UIImage(named: iconName)
    }
    
    func convertToAttributeString(text : NSString)->NSMutableAttributedString{
        let LINE_SPACE_HEIGHT : CGFloat = 5//stackView!.spacing
        let attributeString = NSMutableAttributedString(string: text as String)
        let style = NSMutableParagraphStyle()
        
        style.lineSpacing = LINE_SPACE_HEIGHT
        style.alignment = NSTextAlignment.Left
        attributeString.addAttribute(NSParagraphStyleAttributeName, value: style, range: NSMakeRange(0 , text.length))
        return attributeString
    }
    
    func updateFontSizeForDevice(){
        if(applicationDelegate.isDeviceScreenLessThan375Points()){
            self.title?.font = UIFont.systemFontOfSize(FONT_SIZE_MINI_SCREEN)
        }
    }
    
    func setSelectedBackgroundView() {
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = JTM_HIGHLIGHT_COLOR
        
        self.selectedBackgroundView = backgroundView
    }
}
