//
//  JTMSearchResultListViewController.swift
//  JobThai
//
//  Created by weerapon on 2/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import Alamofire
import ActionSheetPicker_3_0
import GoogleMobileAds

class JTMSearchResultListViewController : JTMBaseViewController, UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout, JTMSearchResultFilterHeaderDelegate, JTMContentNativeExpressCollectionViewCellDelegate {
    
    // Variable Index PageView
    var pageIndex: SearchResultPageIndex = .LIST_VIEW
    
    var numberOfItemsPerSection = 0
    var indexSelected = -1
//    var isSortFilterChange = false
    
    // CONST
    let HEADER_HEIGHT : CGFloat = 65
    let WIDTH_MARGIN : CGFloat = 16
    let HEIGHT_CELL : CGFloat = 119
    let WIDTH_MARGIN_LOAD_MORE : CGFloat = 8
    let HEIGHT_CELL_AND_MARGIN : CGFloat = 121
    let INDEX_SHOW_BACK_TO_TOP : Int = 10
    let ALPHA_SHOW_BACK_TO_TOP : CGFloat = 0.7
    let ALPHA_HIDE_BACK_TO_TOP : CGFloat = 0
    let CELL_BETWEEN_PADDING   : CGFloat = 0
    let ADS_CELL_HEIGHT         : CGFloat = 120
    let ADS_CONTENT_HEIGHT      : CGFloat = 80
    let ADS_CLOSE_BUTTON_HEIGHT : CGFloat = 20
    
    let CELL_IDENTIFIER = "JTMSearchResultListCollectionViewCell"
    let FOOTER_CELL_IDENTIFIER = "JTMSearchResultListFooterCollectionView"
    let HEADER_VIEW_IDENTIFIER = "JTMSearchResultFilterHeaderView"
    let ADS_IDENTIFIER = "JTMContentNativeExpressCollectionViewCell"
    let CONTENT_ADS_UNIT_ID = "ca-app-pub-3273527279427175/4689205369"
    
    var adsView : GADNativeExpressAdView?
    let test : Bool = true
    let ADS_USERDEFAULT_KEY : String = "ADS_USERDEFAULT_KEY"
    var ADS_SHOW = true // default

//    let CELL_PADDING = UIEdgeInsets(top: 0, left: 8, bottom: 8, right: 8)
    
    // parent
    var searchResultController : JTMSearchResultViewController!
//    var noResultView:JTMNoResultView?
    
    var delegateMainSeachResult : JTMSeachResultClickSubViewDelegate!
    
    @IBOutlet weak var listResultCollectionView : UICollectionView?
    @IBOutlet weak var backToTopButton : UIButton?
    
    func closeAds() {

        // create the alert
        let alert = UIAlertController(title: applicationDelegate.getLocalizeStringForKey("DESCRIPTION_ALERT_ADS"), message: "", preferredStyle: UIAlertControllerStyle.Alert)
        
        // add an action (button)
        alert.addAction(UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("ALERT_OK"), style: UIAlertActionStyle.Default, handler: {(UIAlertAction) -> Void in
            NSUserDefaults.standardUserDefaults().setValue(false, forKey: self.ADS_USERDEFAULT_KEY)
            self.updateAdsStatus()
            self.listResultCollectionView?.reloadData()
            print("==== SUCCESSFULLY REMOVE ADS ====")
            NSNotificationCenter.defaultCenter().postNotificationName("SendCloseAds", object: nil)
            applicationDelegate.trackGoogleAnalyticEvent(CAT_LIST, action: ACTION_CLICK, label: LABEL_CLOSE_ADS)
        }))
        alert.addAction(UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("ALERT_CANCEL"), style: UIAlertActionStyle.Cancel, handler: nil))
        // show the alert
        self.presentViewController(alert, animated: true, completion: nil)
        
////        NSUserDefaults.standardUserDefaults().valueForKey("Ads")
        
    }
    
    func setUpAdsView() {
//        print("collection : \(listResultCollectionView?.frame)")
//        print("scree : \(UIScreen.mainScreen().bounds)")
        if adsView == nil {
            let frame = CGSize(width: DEFAULT_FRAME_WIDTH - WIDTH_MARGIN, height: ADS_CONTENT_HEIGHT + ADS_CLOSE_BUTTON_HEIGHT)
            adsView = GADNativeExpressAdView.init(frame: CGRect(origin: CGPointZero, size: frame))
            adsView?.rootViewController = self
            adsView?.adUnitID = CONTENT_ADS_UNIT_ID
        }
        
        let request = GADRequest()
        // ADS SETTING LIST
        if ADS_SIMULATION {
            request.testDevices = [ kGADSimulatorID ];
        }
        else if test {
            request.testDevices = ["2077ef9a63d2b398840261c8221a0c9b"]
        }
        adsView?.loadRequest(request)
    }
    
    func updateAdsStatus() {
        ADS_SHOW = NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY) as! Bool
        print("==== ADS IS \(ADS_SHOW) ====")
        
        if ADS_SHOW {
            searchResultController.ADS_COUNT = 1 // default
        }
        else {
            searchResultController.ADS_COUNT = 0
        }
        setNumberOfItem()
    }
    
    func updateCloseAdsCell() {
        listResultCollectionView?.reloadData()
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
    
        self.registerNib()

        //updateAdsStatus()
        
        NSNotificationCenter.defaultCenter().addObserver(self, selector: #selector(updateCloseAdsCell) , name: "SendCloseAds", object: nil)
    }
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        
        if (searchResultController.isLoadFirstService) {
            self.delegateMainSeachResult.setSeachMainPosition(self, position: (self.searchResultController.searchResultData?.countAllJob)!)
            if (self.searchResultController.searchResultData?.countAllJob == 0) {
//                self.noResultView?.hidden = false
                self.delegateMainSeachResult.displayNoResult()
            }
        }
        
        setUpAdsView()
        updateAdsStatus()
        listResultCollectionView?.reloadData()
    
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
//        initNoResultView()
        initialData()
        
        print("SearchResultList viewWillAppear")
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_SEARCH_RESULT_LIST)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_LIST, action: ACTION_VIEW, label: LABEL_VIEW_RESULT_LIST)
        
//        if isSortFilterChange {
//            onClickBackToTop()
//        }
    }
    
    override func setControllerFlags() {
        isPresentedInOtherController = true
    }
    
    //MARK:- On Retry Connection
    override func onRetryConnection() {
        super.onRetryConnection()
        searchResultController.seachResultMainSeachResult.connectionErrorView?.alpha = VIEW_HIDE_ALPHA
        if !(searchResultController.isLoadFirstService)
            || listResultCollectionView!.visibleCells().contains({$0.isKindOfClass(JTMSearchResultListFooterCollectionView)}) {
                callService()
        }
    }
    
    //MARK:- Manage View On Error
    override func manageViewOnError(view: UIView) {
        super.manageViewOnError(view)
        if !(searchResultController.isLoadFirstService) {
            if (view == noInternetView) {
                searchResultController.seachResultMainSeachResult.noInternetView?.alpha = VIEW_SHOW_ALPHA
//                setAlphaShowToView(searchResultController.seachResultMainSeachResult.noInternetView!)
            } else {
                searchResultController.seachResultMainSeachResult.connectionErrorView?.alpha = VIEW_SHOW_ALPHA
//                setAlphaShowToView(searchResultController.seachResultMainSeachResult.connectionErrorView!)
            }
        }
    }
    
    func initialData(){
        // Hidden Back to top
        self.backToTopButton!.alpha = self.ALPHA_HIDE_BACK_TO_TOP
        listResultCollectionView?.accessibilityIdentifier = ID_SEARCH_RESULT_LIST_COLLECTION_VIEWS
        
        
        // Load Data
        if searchResultController.searchResultData?.jobList.count == nil && !(searchResultController.isLoadFirstService){
            callService()
        } else {
            setNumberOfItem()
            listResultCollectionView?.reloadData()
//            setHighlight()
        }
    }
    
    func registerNib() {
        listResultCollectionView?.registerNib(UINib(nibName: CELL_IDENTIFIER, bundle: nil), forCellWithReuseIdentifier: CELL_IDENTIFIER)
        listResultCollectionView?.registerNib(UINib(nibName: FOOTER_CELL_IDENTIFIER, bundle: nil), forCellWithReuseIdentifier: FOOTER_CELL_IDENTIFIER)
        listResultCollectionView?.registerNib(UINib(nibName: HEADER_VIEW_IDENTIFIER, bundle: nil), forSupplementaryViewOfKind: UICollectionElementKindSectionHeader, withReuseIdentifier: HEADER_VIEW_IDENTIFIER)
        listResultCollectionView?.registerNib(UINib(nibName: ADS_IDENTIFIER, bundle: nil), forCellWithReuseIdentifier: ADS_IDENTIFIER)
    }
    
    func callService() {
        let serviceController = JTMServiceController()
        let url = getServiceSearchResult()
        
        var params = self.searchResultController.getParamForSearch()
        params["page"] = self.searchResultController.nextPage
        self.delegateMainSeachResult.setButtonEnableStatus(false)
        searchResultController.enableSwipePageView(false)
        searchResultController.isLoadingService = true
        
        serviceController.requestService(self, urlString: url, params: params, isPresentLoadingIndicator: !searchResultController.isLoadFirstService) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                self.searchResultController.nextPage += 1
                let jsonObject = response!.result.value as? NSMutableDictionary
                if (!self.searchResultController.isLoadFirstService) {
                    self.parseJsonToModel(jsonObject!)
                    self.searchResultController.isLoadFirstService = true
                    self.delegateMainSeachResult!.setSeachMainPosition(self, position: (self.searchResultController.searchResultData?.countAllJob)!)
                } else {
                    self.addJobList(jsonObject!)
                }
                self.listResultCollectionView?.reloadData()
            } else if (status == .CONNECTION_UNREACHABLE) {
                if !self.searchResultController.isFirstNotConnectInternet {
                    self.searchResultController.seachResultMainSeachResult.showAlertNoNetworkIsReachable()
                    self.searchResultController.isFirstNotConnectInternet = true
                }
            }
            self.delegateMainSeachResult.setButtonEnableStatus(true)
            self.searchResultController.enableSwipePageView(true)
            self.searchResultController.isLoadingService = false
        }
    }
    
    func parseJsonToModel(jsonResult : NSMutableDictionary) {
        self.searchResultController.searchResultData = SearchResultModel(result: jsonResult)
        self.searchResultController.allCountPage = (self.searchResultController.searchResultData?.countPage)!
        //searchResultController.ADS_SHOW = (searchResultController.searchResultData?.showAds)!
        searchResultController.updateAdsPosition()
        setNumberOfItem()
//        self.noResultView?.hidden = (self.searchResultController.searchResultData?.countAllJob == 0) ? false : true
        if (self.searchResultController.searchResultData?.countAllJob == 0) {
            self.delegateMainSeachResult.displayNoResult()
            self.delegateMainSeachResult.hideSearchMainPosition(self)
        }
        
        self.delegateMainSeachResult.updateMapButtonEnable((self.searchResultController.searchResultData?.isHasResultMap)!)
        self.searchResultController.updatePageTitleList()
    }
    
    func addJobList(jsonResult : NSMutableDictionary) {
        let searchJobObject = SearchResultModel(result: jsonResult)
        self.searchResultController.searchResultData!.jobList = self.searchResultController.searchResultData!.jobList + searchJobObject.jobList
        
        setNumberOfItem()
    }
    
    func setNumberOfItem() {
        if self.searchResultController.searchResultData == nil {
            self.numberOfItemsPerSection = 0
        } else if self.searchResultController.nextPage <= self.searchResultController.allCountPage/*(self.searchResultController.searchResultData?.jobList.count < self.searchResultController.searchResultData?.countAllJob)*/ {
            self.numberOfItemsPerSection = (self.searchResultController.searchResultData?.jobList.count)! + 1
        } else {
            self.numberOfItemsPerSection = (self.searchResultController.searchResultData?.jobList.count)!
        }
        
        if self.numberOfItemsPerSection > searchResultController.ADS_POSITION_LIST {// && ADS_SHOW {
            self.numberOfItemsPerSection += searchResultController.ADS_COUNT
        }
    }
    
    //MARK:- CollectionView
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        
        let width = collectionView.frame.width

//        return indexPath.row + 1 > (self.searchResultController.searchResultData?.jobList.count)! ? CGSize(width: collectionView.frame.width - self.WIDTH_MARGIN_LOAD_MORE, height: LOADMORE_CELL_HEIGHT) : CGSize(width: collectionView.frame.width - self.WIDTH_MARGIN, height: self.HEIGHT_CELL)
        if indexPath.row == searchResultController.ADS_POSITION_LIST && ADS_SHOW {
            return CGSize(width: width, height: ADS_CELL_HEIGHT + JTM_CELL_BORDER_HEIGHT + ADS_CLOSE_BUTTON_HEIGHT)
        }
        else {
            if indexPath.row + 1 > (self.searchResultController.searchResultData?.jobList.count)! + searchResultController.ADS_COUNT {
                return CGSize(width: width, height: LOADMORE_CELL_HEIGHT)
            }
            else {
                var itemIndex = indexPath.row
                if indexPath.row > searchResultController.ADS_POSITION_LIST && ADS_SHOW  {
                    itemIndex -= 1
                }
                return collectionView.ar_sizeForCellWithIdentifier(CELL_IDENTIFIER, indexPath: indexPath, fixedWidth: width, configuration: { (cellItem) in
                    let jobItem = (self.searchResultController.searchResultData?.jobList[itemIndex])!
                    if let cell = cellItem as? JTMSearchResultListCollectionViewCell {
                        cell.setDataToCell(jobItem, sequence: indexPath.row)
                    }
                })
            }
//            return indexPath.row + 1 > (self.searchResultController.searchResultData?.jobList.count)! + searchResultController.ADS_COUNT ? CGSize(width: collectionView.frame.width - self.WIDTH_MARGIN_LOAD_MORE, height: LOADMORE_CELL_HEIGHT) : collectionView.ar_sizeForCellWithIdentifier(CELL_IDENTIFIER, indexPath: indexPath, fixedWidth: width, configuration: { (var cellItem) in
//                let jobItem = (self.searchResultController.searchResultData?.jobList[indexPath.row])!
//                if let cell = cellItem as? JTMSearchResultListCollectionViewCell {
//                    //print(cell.frame.size.height)
//                    
//                    //cell.delegate = self
//                    cell.setDataToCell(jobItem, sequence: indexPath.row)
//                    cellItem = cell
//                }
//            })//CGSize(width: collectionView.frame.width - DEFAULT_SEARCH_RESULT_CELL_MARGIN, height: self.HEIGHT_CELL)
        }
        
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
//        return WIDTH_MARGIN/2
        return CELL_BETWEEN_PADDING //DEFAULT_SEARCH_RESULT_CELL_MARGIN/2
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        var itemIndex = indexPath.row
        if indexPath.row > searchResultController.ADS_POSITION_LIST && ADS_SHOW {
            itemIndex -= 1
        }
        indexSelected = itemIndex
        if indexPath.row == searchResultController.ADS_POSITION_LIST && ADS_SHOW {
            // ads cell not clickable
        }
        else if  indexSelected + 1 <= (self.searchResultController.searchResultData?.jobList.count)!  {
            // Track Google Analytic Event
            applicationDelegate.trackGoogleAnalyticEvent(CAT_LIST, action: ACTION_CLICK, label: LABEL_JOB_DETAIL)
            self.delegateMainSeachResult?.onClickSubView(self, item: (self.searchResultController.searchResultData?.jobList[itemIndex])!)
        }
        if (indexPath.row > searchResultController.ADS_POSITION_LIST) && ADS_SHOW {
            indexSelected += 1
        }
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.numberOfItemsPerSection
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {

        if  indexPath.row + 1 > (self.searchResultController.searchResultData?.jobList.count)! +    searchResultController.ADS_COUNT {
            
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier(FOOTER_CELL_IDENTIFIER, forIndexPath: indexPath) as? JTMSearchResultListFooterCollectionView
            cell?.accessibilityIdentifier = ID_LOAD_MORE
            return cell!
        }
        else if indexPath.row == searchResultController.ADS_POSITION_LIST && ADS_SHOW {
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier(ADS_IDENTIFIER, forIndexPath: indexPath) as? JTMContentNativeExpressCollectionViewCell
            cell?.delegate = self
            if adsView == nil {
                setUpAdsView()
            }
            
            cell?.updateBorderForCell(indexPath.row)
            
            adsView?.frame = CGRect(origin: CGPoint(x: WIDTH_MARGIN/2,y: ADS_CELL_HEIGHT - ADS_CONTENT_HEIGHT - 10), size: (adsView?.frame.size)!)
            cell?.addSubview(adsView!)
//            cell?.setData(self)
            return cell!
        }
        else {
            var itemIndex = indexPath.row
            if indexPath.row > searchResultController.ADS_POSITION_LIST && ADS_SHOW {
                itemIndex -= 1
            }
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier(CELL_IDENTIFIER, forIndexPath: indexPath) as? JTMSearchResultListCollectionViewCell
            let itemCell = self.searchResultController.searchResultData?.jobList[itemIndex]
            cell?.setDataToCell(itemCell!,sequence: itemIndex)
            return cell!
        }
    }
    
    //MARK:- Collection Header
    func collectionView(collectionView: UICollectionView, viewForSupplementaryElementOfKind kind: String, atIndexPath indexPath: NSIndexPath) -> UICollectionReusableView {
        
        if (kind == UICollectionElementKindSectionHeader) {
            let headerView = collectionView.dequeueReusableSupplementaryViewOfKind(UICollectionElementKindSectionHeader,
                                                                                        withReuseIdentifier: HEADER_VIEW_IDENTIFIER,
                                                                                        forIndexPath: indexPath) as! JTMSearchResultFilterHeaderView
            headerView.delegate = self
            headerView.accessibilityIdentifier = ID_SORT_FILTER_HEADER_CELL
            headerView.setSortFilter(self.searchResultController.searchResultSortFilterList[self.searchResultController.sortFilterIndex].localizeKey!)
            return headerView
        }
        
        return UICollectionReusableView()
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, referenceSizeForHeaderInSection section: Int) -> CGSize {
        if (numberOfItemsPerSection > 0) {
            return CGSize(width: collectionView.frame.width, height: HEADER_HEIGHT)
        } else {
            return CGSizeZero
        }
    }
    
    //MARK:- Header View Delegate
    func onClickCollectionHeader(headerView: JTMSearchResultFilterHeaderView) {
        if (applicationDelegate.appSetting?.isNetworkReachable)! {
            showSortFilterPickerView()
        }
    }
    
    //MARK:- Sort Filter Picker View
    func showSortFilterPickerView() {
        var sortFilterList = [String]()
        for sortFilterItem in self.searchResultController.searchResultSortFilterList {
            sortFilterList.append(applicationDelegate.getLocalizeStringForKey(sortFilterItem.localizeKey!))
        }
        
        print("sortFilterList : \(sortFilterList[0])")
        
        let currentFilter = self.searchResultController.sortFilterIndex
        
        let actionPicker = ActionSheetStringPicker(title: "",
                                                rows: sortFilterList,
                                                initialSelection: currentFilter,
                                                doneBlock: { (picker, row, value) -> Void in
                                                   self.updateSearchResultByFilterAtIndex(row)
                                                }, cancelBlock: { (picker) -> Void in
                                                    
                                                }, origin: self.view)
        
        actionPicker.setCancelButton(UIBarButtonItem(title: applicationDelegate.getLocalizeStringForKey("Cancel"), style: UIBarButtonItemStyle.Plain, target: self, action: nil))
        actionPicker.setDoneButton(UIBarButtonItem(title: applicationDelegate.getLocalizeStringForKey("Done"), style: UIBarButtonItemStyle.Done, target: self, action: nil))
        actionPicker.tapDismissAction = TapAction.Cancel
        
        actionPicker.showActionSheetPicker()
    }
    
    func updateSearchResultByFilterAtIndex(index: Int) {
    	let selectedFilter = self.searchResultController.searchResultSortFilterList[index].localizeKey!
        
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_LIST, action: ACTION_CLICK, label: getLabelNameSort(applicationDelegate.getLocalizeStringForKey(selectedFilter)))
        
        if (self.searchResultController.sortFilterIndex != index) {
        
            self.searchResultController.setSortFilter(index)
//            self.setNumberOfItem()
//            self.listResultCollectionView?.reloadData()
//            isSortFilterChange = false
            self.callService()
        }
    }
    
    // Mark: Call the Method to load More Data...
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let offset : CGPoint = scrollView.contentOffset;
        let bounds : CGRect = scrollView.bounds;
        let size : CGSize = scrollView.contentSize;
        let inset : UIEdgeInsets = scrollView.contentInset;
        let y : CGFloat = offset.y + bounds.size.height - inset.bottom;
        let h  : CGFloat = size.height;
        
        if(y > h - RELOAD_DISTANCE){
            if !isLoadingService && !(searchResultController.isLoadingService) && self.searchResultController.nextPage <= self.searchResultController.allCountPage {
                callService()
            }
        }
        
        let index = (Int)(offset.y / self.HEIGHT_CELL_AND_MARGIN) + 1
        
        if(index >= self.INDEX_SHOW_BACK_TO_TOP) {
            self.backToTopButton!.alpha = self.ALPHA_SHOW_BACK_TO_TOP
        } else {
            self.backToTopButton!.alpha = self.ALPHA_HIDE_BACK_TO_TOP
        }
    }
    
    // Mark :: OnClick Button Back To Top
    @IBAction func onClickBackToTop() {
//        listResultCollectionView?.scrollToItemAtIndexPath(NSIndexPath(forRow: 0, inSection: 0), atScrollPosition: UICollectionViewScrollPosition.Top, animated: false)
        listResultCollectionView?.setContentOffset(CGPoint(x: 0, y: 0), animated: true)
    }
    
    // Mark: SetHighlight Cell Seclected
    func setHighlight() {
       self.listResultCollectionView?.selectItemAtIndexPath(NSIndexPath(forItem: indexSelected, inSection: 0), animated: false, scrollPosition: .None)
    }
    
}

protocol JTMJobsListSearchResultDelegate {
    func onClickJobList(fromPage : JTMSearchResultListViewController, itemJob : JobItem)
}