//
//  JTMTextField.swift
//  JobThai
//
//  Created by tayathorn on 5/31/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMTextField : UITextField {

    // MARK :- Padding
    let padding = UIEdgeInsets(top: 0, left: 10, bottom: 0, right: 10);
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        
        self.layer.borderWidth = 1
        self.layer.borderColor = UIColor(hexString: "CCCCCC").CGColor
        self.layer.cornerRadius = 4
//        self.font?.fontWithSize(5)
        self.font = UIFont(name: "HelveticaNeue", size: 13)

    }
    
    // MARK :- Padding Cursor & Placeholder
    
    override func textRectForBounds(bounds: CGRect) -> CGRect {
        return self.newBounds(bounds)
    }
    
    override func placeholderRectForBounds(bounds: CGRect) -> CGRect {
        return self.newBounds(bounds)
    }
    
    override func editingRectForBounds(bounds: CGRect) -> CGRect {
        return self.newBounds(bounds)
    }
    
    private func newBounds(bounds: CGRect) -> CGRect {
        
        var newBounds = bounds
        newBounds.origin.x += padding.left
        newBounds.origin.y += padding.top
        newBounds.size.height -= padding.top + padding.bottom
        newBounds.size.width -= padding.left + padding.right
        return newBounds
    }
    
    // Mark-: event COPY & PASTE
    override func canPerformAction(action: Selector, withSender sender: AnyObject?) -> Bool {
        return false
    }
    
    func isValidEmailFormat() -> Bool  {
        let email = self.text
        let trimEmail = email!.stringByTrimmingCharactersInSet(NSCharacterSet.whitespaceAndNewlineCharacterSet())
        let regexPattern = "^[A-Z0-9a-z._+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,}$"
        
        return NSPredicate(format: "SELF MATCHES %@", regexPattern).evaluateWithObject(trimEmail)
    }
    
}

//class JTMTextFiledPreventCopyPaste : JTMTextField {
//    // MARK :- Prevent COPY & PASTE
//    override func canPerformAction(action: Selector, withSender sender: AnyObject?) -> Bool {
//        return false
//    }
//}
