//
//  JTMUrgentJobsView.swift
//  JobThai
//
//  Created by pinyo on 1/29/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation
import UIKit

class JTMUrgentJobsView : UIView {
    
    @IBOutlet var urgentJobsCollectionView : JTMCollectionView!
    
    var delegate : JTMUrgentJobsViewDelegate?
    var view: UIView!
    var urgentJobsDataArr = [UrgentJobsModel]()
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMUrgentJobsView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    //MARK : Set UrgentJobs Data
    func setUrgentJobsData( data : [UrgentJobsModel]){
        self.urgentJobsDataArr = data
        self.urgentJobsCollectionView?.reloadData()
    }
    
}

//MARK : UICollectionView Delegate
extension JTMUrgentJobsView : UICollectionViewDelegate , UICollectionViewDataSource , UICollectionViewDelegateFlowLayout{
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        urgentJobsCollectionView?.registerNib(UINib(nibName: "JTMUrgentJobsCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMUrgentJobsCollectionViewCell")
        //Set Accessibility ID
        urgentJobsCollectionView.accessibilityIdentifier = ID_URGENT_JOBS_COLLECTION_VIEW
    }
    
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.urgentJobsDataArr.count
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("JTMUrgentJobsCollectionViewCell", forIndexPath: indexPath) as! JTMUrgentJobsCollectionViewCell
        
        cell.setCellData(urgentJobsDataArr[indexPath.row])

        return cell
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        delegate?.urgentJobsDidSelect(self, item: urgentJobsDataArr[indexPath.row])
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        print("size :: \(urgentJobsCollectionView.dynamicSize)")
        return urgentJobsCollectionView.dynamicSize
    }
}

protocol JTMUrgentJobsViewDelegate{
    func urgentJobsDidSelect(urgentJobsView : JTMUrgentJobsView , item : UrgentJobsModel)
}