//
//  JTMViewedByCompaniesViewController.swift
//  JobThai
//
//  Created by kanya on 1/12/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMViewedByCompaniesViewController: JTMBaseMenuViewController, UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout {

    // Constance
    let WIDTH_MARGIN : CGFloat = 4
    let HEIGHT_CELL : CGFloat = 126
    let WIDTH_MARGIN_LOAD_MORE : CGFloat = 8
    let HEIGHT_CELL_AND_MARGIN : CGFloat = 134 // HEIGHT_CELL +  DEFAULT_CELL_MARGIN/2(16)
    let INDEX_SHOW_BACK_TO_TOP : Int = 10
    let ALPHA_SHOW_BACK_TO_TOP : CGFloat = 0.7
    let ALPHA_HIDE_BACK_TO_TOP : CGFloat = 0
    let NUMBER_OF_SECCTION : Int = 1
    let NUMBER_CHECK_CLOSE_JOB = 0
    let PADDING_SIZE : CGFloat = 15
    let PADDING_TOP : CGFloat = 10
    let CELL_BETWEEN_PADDING : CGFloat = 0
    
    // Service
    var currentPage = 1
    var totalPage : Int?
    var numberOfItemsPerSection = 0
    var isLoadFirstService : Bool = false
    var isSelectedCell : Bool = false
    
    var noResultView : JTMResumeNoResultView?
    
    // Model
    var viewedByCompanyData : ViewedByCompanyModel?
    
    @IBOutlet weak var viewedByCompaniesCollectionView : UICollectionView?
    @IBOutlet weak var backToTopButton: UIButton!
    @IBOutlet weak var prefixCompany: UILabel?
    @IBOutlet weak var positionCompany: UILabel?
    @IBOutlet weak var bgPosition: UIView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.registerNib()
        self.setAccessibilityIdentifier()
        self.initQuickSearchNavigationItemButton()
    }
    
    override func viewWillAppear(animated: Bool) {
        
        self.initViewWillAppear()
        
        print("ViewedByCompanies")
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_VIEWED_BY_COMPANY)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_VIEWED_BY_COMPANY, action: ACTION_VIEW, label: LABEL_VIEW_COMPANY)
        
        super.viewWillAppear(animated)
        
    }
    
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        
        self.noResultView?.frame = self.view.bounds
        
    }

    override func viewDidDisappear(animated: Bool) {
        if !(self.isSelectedCell) {
            self.noResultView?.hidden = true
//            self.viewedByCompanyData?.viewedByCompanyList.removeAll()
            clearControllerData()
            self.viewedByCompaniesCollectionView!.reloadData()
        }
    }
    
    override func setControllerFlags() {        
        isNeedToDimOnConnectionError = true
        isCanUseAfterLogInOnly = true
    }
    
    override func clearControllerData() {
        viewedByCompanyData = nil
        isLoadFirstService = false
        isLoadingService = false
        currentPage = 1
        numberOfItemsPerSection = 0
    }
    
    override func onLanguageChange(){
        super.onLanguageChange()
        self.title = applicationDelegate.getLocalizeStringForKey("NAV_TITLE_VIEWED_BY_COMPANY")
    }

    //MARK:- Connection Error
    override func onRetryConnection() {
        super.onRetryConnection()
        if (applicationDelegate.appSetting?.isLogin)!
            && ((viewedByCompanyData == nil) || viewedByCompaniesCollectionView!.visibleCells().contains({$0.isKindOfClass(JTMViewedByCompanyLoadmoreCollectionViewCell)})) {
            callService()
        }
    }
    
    //MARK:- Manage View On Error
    override func manageViewOnError(view: UIView) {
        super.manageViewOnError(view)
        if (viewedByCompanyData == nil) {
            setAlphaShowToView(view)
        }
    }
    
    //Mark:- UIBarButton
    override func genUISearchMenuButton() -> UIBarButtonItem? {
        return nil
    }
    
    func initViewWillAppear() {
        if (applicationDelegate.appSetting?.isLogin == false) {
            manageViewOnError(connectionErrorView!)
        } else if !(self.isSelectedCell) {
            // Initial Data About Service
            self.currentPage = 1
            self.isLoadFirstService = false
            self.isLoadingService = false
            self.numberOfItemsPerSection = 0
            
            // setup ui
            self.setUpHideUI()
            self.initNoResult()
            
            // Load Data
            callService()
        } else {
            self.isSelectedCell = false
        }
    }
    
    func initNoResult() {
        self.noResultView = JTMResumeNoResultView(frame: self.view.bounds)
        self.noResultView?.setNoResultForAppliedJob()
        self.view.addSubview(self.noResultView!)
    }
    
    func setAccessibilityIdentifier() {
        self.backToTopButton.accessibilityIdentifier = BACKTOTOP_VIEWED_BY_COMPANY
        self.viewedByCompaniesCollectionView?.accessibilityIdentifier = VIEWED_BY_COMPANIES_COLLECTION_VIEWS
        self.noResultView?.accessibilityIdentifier = ID_VIEWED_BY_COMPANIES_NO_RESULT
    }
    
    func registerNib() {
        self.viewedByCompaniesCollectionView!.registerNib(UINib(nibName: "JTMViewedByCompanyCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMViewedByCompanyCollectionViewCell")
        self.viewedByCompaniesCollectionView?.registerNib(UINib(nibName: "JTMViewedByCompanyLoadmoreCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMViewedByCompanyLoadmoreCollectionViewCell")
    }
    
    // Mark:- SetUp UI
    func setUpHideUI() {
        self.prefixCompany?.hidden = true
        self.positionCompany?.hidden = true
        self.bgPosition?.hidden = true
        self.viewedByCompaniesCollectionView?.hidden = true
        self.backToTopButton.alpha = self.ALPHA_HIDE_BACK_TO_TOP
    }
    
    // Mark-: Set UI After Load Service Finished
    func setUpUIAfterLoadService() {
        self.prefixCompany?.hidden = false
        self.positionCompany?.hidden = false
        self.bgPosition?.hidden = false
        self.viewedByCompaniesCollectionView?.hidden = false
    }
    
    // Mark-: Set Position Tabbar
    func setNumOfPosition(position : Int) {
        self.positionCompany?.text = "\(position)"
        self.prefixCompany?.text = applicationDelegate.getLocalizeStringForKey("PREFIX_COMPANY")
    }
    
    // Mark-: Call Service
    func callService() {
        
        let serviceController = JTMServiceController()
        let url = getServiceViewedByCompany()
        let token = applicationDelegate.appSetting?.userData?.token
        let sessionId = applicationDelegate.appSetting?.userData?.sessionId
        let param  : [String: AnyObject] = [
            "page"      : self.currentPage,
            "action"    : "list",
            "token"     : token!,
            "sessionId" : sessionId!
        ]
        
        print("page = \(self.currentPage)")
        serviceController.requestService(self, urlString: url, params: param, isPresentLoadingIndicator: !isLoadFirstService) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                let jsonObject = response!.result.value as? NSMutableDictionary
                if(!self.isLoadFirstService) {
                    self.parseJsonToModel(jsonObject!)
                    self.setNumOfPosition((self.viewedByCompanyData?.countAllViews)!)
                    self.setUpUIAfterLoadService()
                    self.isLoadFirstService = true
                } else {
                    self.addAppliedJobList(jsonObject!)
                }
                self.viewedByCompaniesCollectionView!.reloadData()
                self.currentPage += 1
            }
        }
    }

    // Mark-: PasreJson
    func parseJsonToModel(jsonResult : NSMutableDictionary) {
        self.viewedByCompanyData = ViewedByCompanyModel(jsonResult: jsonResult)
        self.totalPage = self.viewedByCompanyData?.countPage
        self.setNumberOfItem()
        self.noResultView?.hidden = (self.viewedByCompanyData?.countAllViews == 0) ? false : true
        if self.viewedByCompanyData?.countAllViews == 0 {
            self.noResultView?.setNoResult(applicationDelegate.getLocalizeStringForKey("ALERT_NORESULT"), isHideDescription: true, pathImage: "ic_viewed_by_company_noresult")
        }
    }
    
    func addAppliedJobList(jsonResult : NSMutableDictionary) {
        let viewByCompanyObject = ViewedByCompanyModel(jsonResult: jsonResult)
        self.viewedByCompanyData?.viewedByCompanyList = (self.viewedByCompanyData?.viewedByCompanyList)! + viewByCompanyObject.viewedByCompanyList
        
        setNumberOfItem()
    }
    
    func setNumberOfItem() {
        if viewedByCompanyData == nil {
            self.numberOfItemsPerSection = 0
        }else if self.currentPage < self.totalPage {
            self.numberOfItemsPerSection = (self.viewedByCompanyData?.viewedByCompanyList.count)! + 1
        } else {
            self.numberOfItemsPerSection = (self.viewedByCompanyData?.viewedByCompanyList.count)!
        }
    }
    
    // Mark-: Function Manage Open Alert and New View
    func onClickCell(item : ViewedByCompanyItem) {
        if (item.companyPositions > self.NUMBER_CHECK_CLOSE_JOB) {
            let jobDetailStoryBoard = UIStoryboard(name: "JobDetail", bundle: nil)
            let jobDetail = jobDetailStoryBoard.instantiateViewControllerWithIdentifier("JTMJobDetailViewController") as? JTMJobDetailViewController
            jobDetail!.openPageType = IndexJobDetailPage.ALL_POSITION_PAGE
            jobDetail?.companyCode = item.companyCode!
            self.navigationController?.pushViewController(jobDetail!, animated: true)
        } else {
            self.showAlertWithData(applicationDelegate.getLocalizeStringForKey("ALERT_COMPANY_CLOSED_JOB"), message: nil, completionHandler: nil, actionList: nil)
        }
    }
    
    // Mark-: Delegate CollectionView
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return self.NUMBER_OF_SECCTION
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.numberOfItemsPerSection
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        let indexSelected = indexPath.row
        if indexSelected + 1 <= self.viewedByCompanyData?.viewedByCompanyList.count {
            
            // Track Google Analytic Event
            applicationDelegate.trackGoogleAnalyticEvent(CAT_VIEWED_BY_COMPANY, action: ACTION_CLICK, label: LABEL_JOB_DETAIL)
            
            self.onClickCell((self.viewedByCompanyData?.viewedByCompanyList[indexSelected])!)
            self.isSelectedCell = true
        }
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        if indexPath.row + 1 > self.viewedByCompanyData?.viewedByCompanyList.count {
            let cellLoadmore = collectionView.dequeueReusableCellWithReuseIdentifier("JTMViewedByCompanyLoadmoreCollectionViewCell", forIndexPath: indexPath) as? JTMViewedByCompanyLoadmoreCollectionViewCell
            cellLoadmore?.accessibilityIdentifier = ID_VIEWED_BY_COMPANIES_LOAD_MORE
            return cellLoadmore!
        } else {
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier("JTMViewedByCompanyCollectionViewCell", forIndexPath: indexPath) as? JTMViewedByCompanyCollectionViewCell
            let itemCompany = self.viewedByCompanyData?.viewedByCompanyList[indexPath.row]
            cell!.setDataToCell(indexPath.row + 1, itemCompany: itemCompany!)
            return cell!
        }
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
//        return indexPath.row + 1 > self.viewedByCompanyData?.viewedByCompanyList.count ? CGSize(width: collectionView.frame.width - self.WIDTH_MARGIN_LOAD_MORE, height: LOADMORE_CELL_HEIGHT) :CGSize(width: self.view.frame.width - self.WIDTH_MARGIN, height: self.HEIGHT_CELL)
        
        return indexPath.row + 1 > self.viewedByCompanyData?.viewedByCompanyList.count ? CGSize(width: collectionView.frame.width, height: LOADMORE_CELL_HEIGHT) :CGSize(width: self.view.frame.width , height: self.HEIGHT_CELL)
    }
    
//    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAtIndex section: Int) -> UIEdgeInsets {
//        return UIEdgeInsets(top: PADDING_SIZE, left: PADDING_SIZE, bottom: 0, right: PADDING_SIZE)
//    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
        return CELL_BETWEEN_PADDING
    }
    
    func collectionView(collectionView: UICollectionView, didHighlightItemAtIndexPath indexPath: NSIndexPath) {
        if indexPath.row + 1 <= self.viewedByCompanyData?.viewedByCompanyList.count {
            let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMViewedByCompanyCollectionViewCell
            cell?.backgroundColor = JTM_HIGHLIGHT_COLOR
        }
    }
    
    func collectionView(collectionView: UICollectionView, didUnhighlightItemAtIndexPath indexPath: NSIndexPath) {
        if indexPath.row + 1 <= self.viewedByCompanyData?.viewedByCompanyList.count {
            let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMViewedByCompanyCollectionViewCell
            cell?.backgroundColor = UIColor.whiteColor()
        }
    }
    
    // MARK: - Scroll
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let offset : CGPoint = scrollView.contentOffset;
        let bounds : CGRect = scrollView.bounds;
        let size : CGSize = scrollView.contentSize;
        let inset : UIEdgeInsets = scrollView.contentInset;
        let y : CGFloat = offset.y + bounds.size.height - inset.bottom;
        let h  : CGFloat = size.height;
        
        if(y > h - RELOAD_DISTANCE){
            if !isLoadingService && (self.currentPage <= self.totalPage) {
//                self.currentPage++
                callService()
            }
        }
        
//        let currentScrollOffset = viewedByCompaniesCollectionView!.contentOffset.y + viewedByCompaniesCollectionView!.frame.height
//        let cellOffset = HEIGHT_CELL * CGFloat(INDEX_SHOW_BACK_TO_TOP - 1) + (DEFAULT_CELL_MARGIN/2) * CGFloat(INDEX_SHOW_BACK_TO_TOP)
//        
//        if(currentScrollOffset >= cellOffset) {
//            self.backToTopButton!.alpha = self.ALPHA_SHOW_BACK_TO_TOP
//        } else {
//            self.backToTopButton!.alpha = self.ALPHA_HIDE_BACK_TO_TOP
//        }
        
        let visibleIndex = viewedByCompaniesCollectionView!.indexPathsForVisibleItems()
        
        if visibleIndex.count > 0 {
            let arrayVisible = visibleIndex.sort {$0.row < $1.row}
            let index = arrayVisible.last!.row + 1
            
            if(index >= self.INDEX_SHOW_BACK_TO_TOP && scrollView.contentOffset.y != 0) {
                self.backToTopButton!.alpha = self.ALPHA_SHOW_BACK_TO_TOP
            } else {
                self.backToTopButton!.alpha = self.ALPHA_HIDE_BACK_TO_TOP
            }
        }
        
    }
    
    @IBAction func onClickBackToTopButton(sender: AnyObject) {
        self.viewedByCompaniesCollectionView!.setContentOffset(CGPoint(x: 0, y: 0), animated: true)
    }

}
