//
//  JTMViewedByCompanyCollectionViewCell.swift
//  JobThai
//
//  Created by weerapon on 5/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

class JTMViewedByCompanyCollectionViewCell: UICollectionViewCell {
    
    let SELECTED_BODER_WIDTH: CGFloat = 2.5
    let BORDER_WIDTH: CGFloat = JTM_CELL_BORDER_HEIGHT//2
    let BORDER_COLOR = JTM_CELL_SEPERATOR_COLOR//JTM_BROWSEJOB_HOME_BG_COLOR
    
    @IBOutlet weak var sequence : JTMLabel?
    @IBOutlet weak var date : JTMLabel?
    @IBOutlet weak var companyLogo: UIImageView?
    @IBOutlet weak var companyName: JTMLabel!
    @IBOutlet weak var companyDetail: JTMLabel!
    @IBOutlet weak var imageClosedJob: UIImageView!
    @IBOutlet weak var bottomBorderView: UIView!
    @IBOutlet weak var topBorderView: UIView!
    @IBOutlet weak var topBorderHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var bottomBorderHeightConstraint: NSLayoutConstraint!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.setCellBorder()
//        self.setSelectedBackgroundView()
    }
    
    func setCellBorder() {
//        self.layer.borderWidth = self.BORDER_WIDTH
//        self.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        
        //top border
        self.topBorderView.backgroundColor = BORDER_COLOR
        self.topBorderHeightConstraint.constant = BORDER_WIDTH
        
        //set bottom border
        self.bottomBorderView.backgroundColor = BORDER_COLOR
        self.bottomBorderHeightConstraint.constant = BORDER_WIDTH
    }
    
    func setSelectedBackgroundView() {
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = UIColor.clearColor()
        backgroundView.layer.borderWidth = self.SELECTED_BODER_WIDTH
        backgroundView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        
        self.selectedBackgroundView = backgroundView
    }
    
    func setDataToCell(sequence : Int, itemCompany : ViewedByCompanyItem) {
        self.sequence?.text = ("\(sequence)")
        self.date?.text = itemCompany.date
        self.topBorderHeightConstraint.constant = (sequence == 1) ? BORDER_WIDTH : 0
        
        self.companyLogo!.hidden = (itemCompany.companyLogo == nil)
        if itemCompany.companyLogo != nil {
            self.companyLogo?.sd_setImageWithURL(itemCompany.companyLogo, placeholderImage: UIImage())
        }
        
        self.companyName.text = itemCompany.companyName
        self.companyDetail.text = itemCompany.companyDetail
        
        self.imageClosedJob.image = UIImage(named: applicationDelegate.getLocalizeStringForKey("CLOSED_JOB_IMAGE"))
        self.imageClosedJob.hidden = (itemCompany.companyPositions! > 0)
        
        self.imageClosedJob.accessibilityIdentifier = (itemCompany.companyPositions! > 0) ? COMPANIES_IMAGE_AVALABLE_JOB : COMPANIES_IMAGE_CLOSE_JOB
    }
    
}