//
//  NoticeModel.swift
//  JobThai
//
//  Created by pinyo on 2/10/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

class NoticeModel {
    var id              : String?
    var title           : String?
    var content         : String?
    var startDate       : String?
    var read            : Bool?
    var contentShowing  : Bool      = false
    var contentHeight   : CGFloat   = 0
    var contentEdgeInset: UIEdgeInsets = UIEdgeInsets(top: 10, left: 22, bottom: 10, right: 22)
    init(){
        
    }
    
    init(notice : NSMutableDictionary){
        self.id             = notice.objectForKey("id") as? String
        self.title          = notice.objectForKey("title") as? String
        self.content        = notice.objectForKey("content") as? String
        self.startDate      = notice.objectForKey("startdate") as? String
        self.contentHeight  = getContentHeight(self.content!)
    }
    
    init(id : String , title : String , content : String , date : String){
        self.id         = id
        self.title      = title
        self.content    = content
        self.startDate  = date
        self.contentHeight  = getContentHeight(self.content!)
    }
    
    //MARK: Calculate Content Size
    func getContentHeight(text : String) -> CGFloat{
        let contentWidth = UIScreen.mainScreen().bounds.width - contentEdgeInset.left - contentEdgeInset.right
        return text.getContentTextFitSize(width: contentWidth).height
        
    }
}