//
//  JTMMapCalloutView.swift
//  ProjectAutoTest
//
//  Created by pinyo on 2/25/16.
//  Copyright © 2016 pinyo. All rights reserved.
//

import Foundation
import UIKit

class TNMapCalloutView : UIControl {
    
    @IBOutlet weak private var titleLabel : UILabel!
    @IBOutlet weak private var jobFirst : UILabel!
    @IBOutlet weak private var jobSecond : UILabel!
    @IBOutlet weak private var jobThird : UILabel!
    @IBOutlet weak private var moreLabel : UILabel!
    
    private var descriptionLabelList : [UILabel] = []
    private var calloutHeaderHeight : CGFloat = 43
    private var calloutJobTitleHeight : CGFloat = 20
    private var moreLabelHeight : CGFloat = 20
    
    var title : String = ""
    var descriptionList : [String] = []

    //MARK: Initial View
    override init(frame: CGRect) {
        super.init(frame: frame)
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }

    override func awakeFromNib() {
        self.descriptionLabelList.append(self.jobFirst)
        self.descriptionLabelList.append(self.jobSecond)
        self.descriptionLabelList.append(self.jobThird)
    }

    ///[TNMapCalloutView] for setTitle and Description in CalloutView
    func setTitleAndDescription(title : String , andDescriptionList _descriptionList : [String] ){
        self.title = title
        self.descriptionList = _descriptionList
        
        self.titleLabel.text = title
        let length = _descriptionList.count
        for index in 0..<length {
            if index < 3{
                let job = _descriptionList[index]
                self.descriptionLabelList[index].text = "\u{2022} " + job
                self.descriptionLabelList[index].hidden = false
            }else{
                break
            }
        }
        if length > 3 {
            self.moreLabel.hidden = false
            self.setFrameForJobTitle(3)
        }else{
            self.moreLabel.hidden = true
            self.moreLabelHeight = 5
            self.setFrameForJobTitle(length)
        }
    }
    
    private func setFrameForJobTitle(numLine : Int){
        let newFrame = self.calloutHeaderHeight + self.calloutJobTitleHeight*CGFloat(numLine) + self.moreLabelHeight
        self.frame = CGRect(origin: CGPointZero, size: CGSize(width: self.frame.width, height: newFrame))
    }
    
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        self.backgroundColor = JTM_SELECTED_CELL_BORDER_COLOR  //  #CCCCCC
    }
    
    override func touchesCancelled(touches: Set<UITouch>?, withEvent event: UIEvent?) {
        self.backgroundColor = UIColor.clearColor()
    }
    
    override func touchesEnded(touches: Set<UITouch>, withEvent event: UIEvent?) {
        self.backgroundColor = UIColor.clearColor()
    }
    
}