//
//  JTMMapCalloutView.swift
//  ProjectAutoTest
//
//  Created by pinyo on 2/25/16.
//  Copyright © 2016 pinyo. All rights reserved.
//

import Foundation
import UIKit

class TNMapCalloutViewAddress : UIControl {
    
    @IBOutlet private var titleLabel : UILabel!
    @IBOutlet private var detailLabel : UILabel!
    
    private var calloutHeaderHeight     : CGFloat = 43
    private var calloutBottomSpace      : CGFloat = 8
    
    var title   : String = ""
    var detail : String = ""
    
    //MARK: Initial View
    override init(frame: CGRect) {
        super.init(frame: frame)
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }

    override func awakeFromNib() {
    }

    ///[TNMapCalloutView] for setTitle and Description in CalloutView
    func setTitleAndAddress(title : String , andDrescription detail : String){
        self.title  = title
        self.detail = detail
        
        self.titleLabel.text    = title
        self.detailLabel.text   = detail
        
         updateCalloutFrame()
    }
    
    private func updateCalloutFrame(){
        detailLabel.updateFrameFitContent()
        
        let labelHeight = detailLabel.frame.size.height
        let frameHeight = calloutHeaderHeight + labelHeight + calloutBottomSpace
        
        var newFrame = self.frame
        newFrame.size.height = frameHeight
        self.frame = newFrame
    }
}

extension UILabel {
    func updateFrameFitContent(){
        let fixedWidth = self.frame.size.width
        let newSize = self.sizeThatFits(CGSize(width: fixedWidth, height: CGFloat.max))
        var newLabelFrame = self.frame
        
        newLabelFrame.size = CGSize(width: max(newSize.width, fixedWidth), height: newSize.height)
        self.frame = newLabelFrame
    }
}
