//
//  TNMapViewController.swift
//  ProjectAutoTest
//
//  Created by pinyo on 3/28/16.
//  Copyright © 2016 pinyo. All rights reserved.
//

import Foundation
import UIKit

class TNMapViewController : UIViewController , TNMapViewDelegate{
    
    @IBOutlet var mapView : TNMapView!
    
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view, typically from a nib.
        setUpMapView()
        
        mapView.setShowUserLocation(true)
        
        setUpAnnotationData()
        setUpAccuracyCircle()
        
        //for set hide accuracy circle annotation
//        mapView.hideAccuracyCircleAnnotation(true)
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    //MARK: Setup MapView
    private func setUpMapView(){
        mapView.setCenterMapViewToBangkok()
        self.mapView!.delegate = self
    }
    
    func setUpAnnotationData(){
        let thinknetAnnotation = mapView.createAnnotationWithJobList("[1] THiNKNET.Co.LTD", jobList: ["iOs Developer" , "Php Developer" ,"Graphics Design"], coordinate: mapView.LOCATION_BANGKOK, userInfo: nil)
        mapView.addAnnotationToMapView(thinknetAnnotation)
        mapView.setCenterMapToCoordinate(thinknetAnnotation.coordinate, animated: true)
        
        var coordinate = CLLocationCoordinate2D(latitude: 13.750390293084857, longitude: 100.41933059692383)
        coordinate = CLLocationCoordinate2D(latitude: 13.659331694429515, longitude: 100.4688549041748)
        
        
        let thinknetAnnotation2 = mapView.createAnnotationWithAddress("[2] THiNKNET.Co.LTD", address: "Bangbo 2342 moo.2 bangplee samutprakarn bangkok 10560\nSDFSFF 02708414141dslkafnjkjdsfkjsnadfkjndskjfkdsjfkdsahfkjasdfkhjafbhdjsabfkdsabhfjasbfk.ans.kfjdn", coordinate: coordinate, userInfo: nil)
        
        if(thinknetAnnotation2 != nil){
            mapView.addAnnotationToMapView(thinknetAnnotation)
        }
    }
    
    func setUpAccuracyCircle(){
        //Circle Data Layer
        let fillColor = UIColor(colorLiteralRed: 0, green: 1, blue: 0, alpha: 0.4)
        let lineColor = UIColor(colorLiteralRed: 1, green: 0, blue: 0, alpha: 0.7)
        let lineWidth : CGFloat = 2
        self.mapView.setAccuracyCircleAnnotationLayer(fillColor: fillColor, lineColor: lineColor, andLineWidth: lineWidth)
    }
    
    
    //MARK: Mapview Delegate
    func mapViewSingleTapOnMap(map: RMMapView, at point: CGPoint) {
        print("Tap On Map")
    }
    
    func mapViewTapOnCalloutAccessoryControl(control: UIControl, forAnnotation annotation: RMAnnotation, onMap map: RMMapView) {
        print("Tap On Callout : \(annotation.title)")
    }
    
}