//
//  TransportationLineModel.swift
//  JobThai
//
//  Created by ForAlL on 2/1/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class TransportationLineModel {

    var categoryName : String?
    var name: String?
    var stationList = [TransportationStationModel]()
    var stationOrderList = [TransportationStationModel]()
    init(){
        
    }
    
    init(name : String , list : [TransportationStationModel]){
        self.name = name
        self.stationList = list
    }
    
    init(name : String , list : [TransportationStationModel] , category : String){
        self.name = name
        self.stationList = list
        self.categoryName = category
    }
    
    init(item : NSMutableDictionary) {
        convertJsonToModel(item)
    }
    
    init(item : NSMutableDictionary , category : String) {
        convertJsonToModel(item)
        self.categoryName = category
    }
    
    func convertJsonToModel(itemLine : NSMutableDictionary){
        self.name = itemLine.objectForKey("name") as? String
        for stationItem in (itemLine.objectForKey("station") as? NSArray)!{
            self.stationList.append(TransportationStationModel(item: (stationItem as? NSMutableDictionary)!))
            self.stationOrderList.append(TransportationStationModel(item: (stationItem as? NSMutableDictionary)!))
        }
        //Sort Station Order List
        self.stationOrderList.sortInPlace{$0.orderNumber < $1.orderNumber}
    }
    
    func setData(name : String , list : [TransportationStationModel]){
        self.name = name
        self.stationList = list
    }
    
    func setData(name : String , list : [TransportationStationModel] , category : String){
        self.name = name
        self.stationList = list
        self.categoryName = category
    }
}
