//
//  JTMAppliedJobViewControllerTests.swift
//  JobThai
//
//  Created by tayathorn on 5/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMAppliedJobViewControllerTests: XCTestCase {
        
    let app = XCUIApplication()
    
    func testJobDetail() {
        
        app.launch()
        sleep(3)
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in With user : vaiohkae@gmail.com
        self.logInWithUserHaveAppliedJob()
        
        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(5)
        
        let collectionView = app.collectionViews[ID_APPLIED_JOBS_COLLECTION_VIEW]
        
        let availableJob = collectionView.cells.containingType(.Image, identifier: "closedJobImage_AVAIL")
        var isFound = false
        
        while collectionView.cells.element.exists {
            if availableJob.element.exists {
                availableJob.elementBoundByIndex(0).tap()
                isFound = true
                break
            }
            collectionView.swipeUp()
        }
        
        if isFound {
            sleep(3)
            app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic back"].tap()
            self.logOut()
        }
        sleep(2)
    }
    
    func testJobDetailClosedJob() {

        app.launch()
        sleep(3)
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in With user : vaiohkae@gmail.com
        self.logInWithUserHaveAppliedJob()

        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(5)
        
        let collectionView = app.collectionViews[ID_APPLIED_JOBS_COLLECTION_VIEW]
        
        let closedJob = collectionView.cells.containingType(.Image, identifier: "closedJobImage_CLOSED")
        var isFound = false
        
        while collectionView.cells.element.exists {
            if closedJob.element.exists {
                closedJob.elementBoundByIndex(0).tap()
                isFound = true
                break
            }
            collectionView.swipeUp()
        }
        
        if isFound {
            sleep(1)
            
            let alertView = app.alerts["alert"]
            let alertButton = alertView.collectionViews.buttons
            let okButton = alertButton.elementBoundByIndex(0)
            okButton.tap()
            
            self.logOut()
        }
        
        sleep(1)
    }
    
    func testBackToTopButton() {

        app.launch()
        sleep(3)
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in With user : vaiohkae@gmail.com
        self.logInWithUserHaveAppliedJob()
        
        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(5)
        
        let collectionView = app.collectionViews[ID_APPLIED_JOBS_COLLECTION_VIEW]
        let backToTopButton = app.buttons["backToTop_Show"]
        
        while collectionView.cells.element.exists {
            collectionView.swipeUp()
            if backToTopButton.exists {
                backToTopButton.tap()
                break
            }
        }
        sleep(1)
        
        self.logOut()
        sleep(1)
    }
    
    func testLoadMore() {
        
        app.launch()
        sleep(3)
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in With user : vaiohkae@gmail.com
        self.logInWithUserHaveAppliedJob()
        
        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(5)
        
        let collectionView = app.collectionViews[ID_APPLIED_JOBS_COLLECTION_VIEW]
        let allPosition = app.staticTexts["positionLabel"].label
        
        while collectionView.cells.element.exists {
            collectionView.swipeUp()
            if collectionView.cells.containingType(.StaticText, identifier: allPosition).element.exists {
                collectionView.swipeUp()
                break
            }
        }
        sleep(1)
        
        self.logOut()
        sleep(1)
    }
    
    func testSearchButton() {
        
        app.launch()
        sleep(3)
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in With user : vaiohkae@gmail.com
        self.logInWithUserHaveAppliedJob()
        
        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(5)
        
        let searchButton = app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        searchButton.tap()
        
        let searchFilterTableView = app.tables["ID_SEARCH_FILTER_TABLE_VIEWS"]
        
        if searchFilterTableView.exists {
            sleep(1)
            app.navigationBars[ID_NAV_BAR_QUICK_SEARCH].buttons["ID_NAV_BAR_QUICK_SEARCH_CANCEL"].tap()
            self.logOut()
            sleep(1)
        } else {
            XCTFail()
        }
    }
    
    func testNoResult() {
        
        app.launch()
        sleep(3)
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        // Log in with user : jtmtester+04@gmail.com
        self.logInWithUserNoResult()
        
        // Select Table Applied Job
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.staticTexts["Applied Jobs"].tap()
        sleep(3)
        
        let collectionView = app.collectionViews[ID_APPLIED_JOBS_COLLECTION_VIEW]
        
        print("count : \(collectionView.cells.count)")
        
        if collectionView.cells.count == 0 {
            sleep(2)
            self.logOut()
            sleep(1)
        } else {
            XCTFail()
        }
    }
    
    func tetete() {
       
        
    }
    
    
}

extension JTMAppliedJobViewControllerTests {
    func logInWithUserHaveAppliedJob() {
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(1).tap()
        
        let username = app.textFields["usernameTextField"]
        username.tap()
        username.clearText()
        username.typeText("vaiohkae@gmail.com")
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testuser")
        
        app.buttons["loginButton"].tap()
        
        sleep(3)
    }
    
    func logInWithUserNoResult() {
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(1).tap()
        
        let username = app.textFields["usernameTextField"]
        username.tap()
        username.clearText()
        username.typeText("jtmtester+04@gmail.com")
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testuser")
        
        app.buttons["loginButton"].tap()
        
        sleep(3)
    }
    
    func logOut() {
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(7).tap()
        let alertLogOut = app.alerts[ID_ALERT_LOGOUT]
        let alertButtonLogOut = alertLogOut.collectionViews.buttons
        let LogOutButton = alertButtonLogOut.elementBoundByIndex(1)
        LogOutButton.tap()
    }
}
