//
//  JTMLoginTests.swift
//  JobThai
//
//  Created by tayathorn on 6/6/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMLoginTests: XCTestCase {
    
    let SLEEP_LAUNCH_APP : UInt32 = 6
    let SLEEP_FINISHED_APP : UInt32 = 2
    let SLEEP_WAITING : UInt32 = 3
    
    let app = XCUIApplication()
    
    func testLinkRegister() {
        self.baseUI()
        
        app.buttons["RegisterButton"].tap()
        sleep(SLEEP_WAITING)
        
        XCTAssertTrue(self.checkNavigationTitle("TEXT_TITLE_REGISTER"))
        
        print("END")
        sleep(SLEEP_FINISHED_APP)
        
    }
    
    func testLinkForgotPassword() {
        self.baseUI()
        
        app.buttons["ForgotPasswordButton"].tap()
        sleep(SLEEP_WAITING)
        
        XCTAssertTrue(self.checkNavigationTitle("NAV_FORGOT_PASSWORD"))
        
        print("END")
        sleep(SLEEP_FINISHED_APP)
    }
    
    func testAlertUserNotActivateEmail() {
        self.baseUI()
        
        let usernameTextField = app.textFields["usernameTextField"]
        usernameTextField.tap()
        usernameTextField.clearText()
        usernameTextField.typeText("vaiohkae+08@gmail.com")
        
        let passwordTextField = app.secureTextFields["passwordTextField"]
        passwordTextField.tap()
        passwordTextField.clearText()
        passwordTextField.typeText("testuser3")
        
        let loginButton = app.buttons["loginButton"]
        loginButton.tap()
        
        sleep(SLEEP_WAITING)
        
        let alert = app.alerts["alert"]
        let textAlertTH = "อีเมลนี้ยังไม่ทำการยืนยันอีเมล กรุณายืนยันอีเมลก่อนเข้าสู่ระบบ"
        let textAlertEN = "This email address is not verified. Please verify your email address."
        
        let boolArrage = compareString(alert.label, localTH: textAlertTH, localEN: textAlertEN)
        XCTAssertTrue(boolArrage)
        
        sleep(SLEEP_FINISHED_APP)
    }
    
}


extension JTMLoginTests {
    func baseUI() {
        app.launch()
        
        sleep(self.SLEEP_LAUNCH_APP)
        
        // Logout and Login
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        if (mainMenu.cells.count == 8) {
            self.logOut()
        }
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        
        mainMenu.cells.elementBoundByIndex(1).tap()
    }
    
    func logOut() {
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(7).tap()
        let alertLogOut = app.alerts[ID_ALERT_LOGOUT]
        let alertButtonLogOut = alertLogOut.collectionViews.buttons
        let LogOutButton = alertButtonLogOut.elementBoundByIndex(1)
        LogOutButton.tap()
    }
    
    func checkNavigationTitle(navTitle : String) -> Bool {
        let navigationTitle = app.navigationBars["ID_MAIN_NAVIGATION_BAR"].staticTexts.element.label
        print("navigationTitle : \(navigationTitle)")
        
        let boolArrage = getLocalizeStringForKeyForUITests(navigationTitle, key: navTitle)
        
        return boolArrage
    }
}