//
//  JTMQuickSearchOnNavBarTest.swift
//  JobThai
//
//  Created by pinyo on 5/3/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMQuickSearchOnNavBarTest: XCTestCase {
    let SLEEP_FOR_UI            : UInt32 = 3
    
    let app = XCUIApplication()
    
    //Case 1 :  Home -> Urgent -> JobDetail -> Search[Nav] -> Quick -> "Search" -> Select JobList[0] -> JobDetail -> Cancel
    func testCaseQuickSearchInJobDetail(){
        //Home
        app.launch()
        sleep(3)
        
        //Select : urgent Jobs at Index 0
        let urgentJobs = app.collectionViews[ID_URGENT_JOBS_COLLECTION_VIEW]
        urgentJobs.cells.elementBoundByIndex(0).tap()
        
        //Select : Quick Search Button on NavBar
        let quickSearchNavBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        quickSearchNavBarButton.tap()
        
        //Select : Quick Search
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        let searchButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchButton.tap()
        
        //Select : List at index 0
        let searchResultListCollectionView = app.collectionViews[ID_SEARCH_RESULT_LIST_COLLECTION_VIEWS]
        searchResultListCollectionView.cells.elementBoundByIndex(0).tap()

        //Select : Cancel on Nav Bar
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        sleep(2)
    }
    
    //Case 2 :  Home -> Search[Nav] -> Quick Search -> "Search" -> JobList[0]
    //          -> Search[Nav] -> Quick -> "Search" -> Select JobList[0] -> JobDetail -> Cancel
    func testCaseQuickSearchFromNavBarInJobList(){
        //Home
        app.launch()
        sleep(3)
        
        //Press : Search button on NavBar
        let searchButton = app.buttons[ID_HOME_SEARCH_BUTTON]
        searchButton.tap()
        
        //Select : Quick Search
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        let searchFilterButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchFilterButton.tap()
        
        //Select : Quick Search Button on NavBar
        let quickSearchNavBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        quickSearchNavBarButton.tap()
        
        //Select : Quick Search
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        searchFilterButton.tap()
        
        //Select : List at index 0
        sleep(SLEEP_FOR_UI)
        let searchResultListCollectionView = app.collectionViews[ID_SEARCH_RESULT_LIST_COLLECTION_VIEWS]
        searchResultListCollectionView.cells.elementBoundByIndex(0).tap()
        
        //Select : Cancel on Nav Bar
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        sleep(2)
    }
    
    //Case 3 :  Home -> BrowseJob[TotalJob] -> Industrial Estate -> Bangkok -> Ladkrabang -> JobList[0]
    //          -> Search[Nav] -> Quick -> "Search" -> Select JobList[0] -> JobDetail -> Cancel
    func testCaseQuickSearchFromBrowseJobInJobList(){
        //Home
        app.launch()
        sleep(3)
        
        //Select : HomeBrowseJob --> TotalJob
        let browseJobTotalJobsBtn = app.buttons[ID_HOME_BROWSE_JOBS_TOTAL_BUTTON]
        browseJobTotalJobsBtn.tap()
        
        //Select : Industrial Estate [index 4]
        let browseJobsModeJobsCollection = app.collectionViews[ID_BROWSE_JOBS_MODE_JOBS_COLLECTION_VIEW]
        browseJobsModeJobsCollection.cells.elementBoundByIndex(4).tap()
        
        //Select : Bangkok [index 0]
        let firstLevelCollectionView = app.collectionViews[ID_BROWSE_JOBS_FIRST_LEVEL_COLLECTION_VIEW]
        firstLevelCollectionView.cells.elementBoundByIndex(0).tap()
        
        //Select : LadKrabang [index 2]
        let secondeLevelTableView = app.tables[ID_BROWSE_JOBS_SECOND_LEVEL_TABLE_VIEW]
        secondeLevelTableView.cells.elementBoundByIndex(2).tap()
        
        //Select : Quick Search Button on NavBar
        let quickSearchNavBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        quickSearchNavBarButton.tap()
        
        //Select : Quick Search
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        let searchFilterButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchFilterButton.tap()
        
        //Select : List at index 0
        let searchResultListCollectionView = app.collectionViews[ID_SEARCH_RESULT_LIST_COLLECTION_VIEWS]
        searchResultListCollectionView.cells.elementBoundByIndex(0).tap()
        
        //Select : Cancel on Nav Bar
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        sleep(2)
    }
    
    //Case 4 :  Home -> Search[Nav] -> Quick Search -> "Search" -> Select JobList[0]
    //          -> Search[Nav] -> Quick Search -> Job Categories -> Cancel
    func testCaseQuickSearchFromNavBarInJobCategories(){
        //Home
        app.launch()
        sleep(3)
        
        //Press : Search button on NavBar
        let searchButton = app.buttons[ID_HOME_SEARCH_BUTTON]
        searchButton.tap()
        
        //Select : Quick Search
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        let searchFilterButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchFilterButton.tap()
        
        //Select : Quick Search Button on NavBar
        let quickSearchNavBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        quickSearchNavBarButton.tap()
        
        //Select : Quick Search
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Location Categories
        let searchFilterDetailTableView = app.tables[ID_SEARCH_FILTER_DETAIL_TABLE_VIEWS]
        searchFilterDetailTableView.cells.elementBoundByIndex(1).tap()
        
        //Select : Cancel on Nav Bar
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        sleep(2)
    }
    
    //Case 5 :  Home -> Search[Nav] -> Quick Search -> "Search" -> Select JobList[0]
    //          -> Search[Nav] -> Quick Search -> Cancel
    func testCaseQuickSearchFromNavBarInMainQuickSearch(){
        //Home
        app.launch()
        sleep(3)
        
        //Press : Search button on NavBar
        let searchButton = app.buttons[ID_HOME_SEARCH_BUTTON]
        searchButton.tap()
        
        //Select : Quick Search
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(0).tap()
        
        //Select : Search button
        let searchFilterButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchFilterButton.tap()
        
        //Select : Quick Search Button on NavBar
        let quickSearchNavBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        quickSearchNavBarButton.tap()
        
        //Select : Quick Search
        searchFilterTableView.cells.elementBoundByIndex(0).tap()

        //Select : Cancel on Nav Bar
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        sleep(2)
    }
}
