//
//  JTMTransportationSearchViewControllerTests.swift
//  JobThai
//
//  Created by pinyo on 5/23/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMTransportationSearchViewControllerTests : XCTestCase {
    
    let SLEEP_FOR_UI            : UInt32 = 3
    let SLEEP_FOR_TRANSITION          : UInt32 = 2
    let SLEEP_FOR_LOAD_SERVICE  : UInt32 = 5
    let SLEEP_FOR_CLOSE_APP     : UInt32 = 3
    
    let app = XCUIApplication()
    let homeSearchButton = XCUIApplication().buttons[ID_HOME_SEARCH_BUTTON]
    
    override func setUp() {
        super.setUp()
        app.launch()
        sleep(SLEEP_FOR_UI)
    }
    
    override func tearDown() {
        super.tearDown()
        sleep(SLEEP_FOR_CLOSE_APP)
    }
    
    //MARK: Test Case
    func testSelectTransportationSecondLevel(){
        selectTransportationSecondLevel()
    }
    
    func testSelectTransportationThirdLevel(){
        selectTransportationThirdLevel()
    }
    
    //MARK: Function Case
    func selectTransportationSecondLevel(){
        var selectTransportString : String = ""
        homeSearchButton.tap()
        openSearchFilterByTransportation()
        
        sleep(SLEEP_FOR_LOAD_SERVICE)
        pressSelectTransportation()
        
        //Select : BRT
        sleep(SLEEP_FOR_TRANSITION)
        selectTransportString += selectMainTransportation(1)
        
        //Select : Sathorn
        sleep(SLEEP_FOR_TRANSITION)
        selectTransportString += " - " + selectSubCategory(1)
        
        sleep(SLEEP_FOR_TRANSITION)
        let currentTransportString = getSelectTransportationString()
        XCTAssertEqual(currentTransportString, selectTransportString, "Invalid value of Select Transportation.")
        
        pressSearchButton()
        
        sleep(SLEEP_FOR_TRANSITION)
        XCTAssert(searchResultMapViewIsVisible(), "SearchResultViewController are not visible.")
    }
    
    func selectTransportationThirdLevel(){
        var selectTransportString : String = ""
        homeSearchButton.tap()
        openSearchFilterByTransportation()
        
        sleep(SLEEP_FOR_LOAD_SERVICE)
        pressSelectTransportation()
        
        //Select : BTS
        sleep(SLEEP_FOR_TRANSITION)
        selectTransportString += selectMainTransportation(3)

        //Select : SukumVit
        sleep(SLEEP_FOR_TRANSITION)
        selectTransportString += " - " + selectCategory(1)
        
        //Select : Saphan Khwai
        sleep(SLEEP_FOR_TRANSITION)
        selectTransportString += " - " + selectSubCategory(2)
        
        sleep(SLEEP_FOR_TRANSITION)
        let currentTransportString = getSelectTransportationString()
        print("Current Transport : " + currentTransportString)
        print("Select  Transport : " + selectTransportString)
        XCTAssertEqual(currentTransportString, selectTransportString, "Invalid value of Select Transportation.")
        
        pressSearchButton()
        
        sleep(SLEEP_FOR_TRANSITION)
        XCTAssert(searchResultMapViewIsVisible(), "SearchResultViewController are not visible.")
    }
    
    //MARK: Function for Action with Any Element
    func selectThaiLanguage(){
        toggleSideMenu()
        selectSideMenu("Settings")
        selectLanguageInSetting(selectEnglish: true)
        //Function Select Language Not Complete
    }
    
    func selectEnglishLanguage(){
        
    }
    
    func toggleSideMenu(){
        let sideMenuButton = app.buttons[ID_MAIN_NAVIGATION_BAR_MENU_BUTTON]
        sideMenuButton.tap()
    }
    
    func selectSideMenu(title : String){
        let sideMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        let selectMenu = sideMenu.cells.staticTexts[title]
        selectMenu.tap()
    }
    
    func selectLanguageInSetting(selectEnglish english : Bool){
        let settingTableView = app.tables[ID_SETTING_TABLE_VIEWS]
        let languageCell = settingTableView.cells.elementBoundByIndex(0)
        let currentIsEnglish = (getTitleFromCell(languageCell) == "English") ? true : false
        if(english && !currentIsEnglish){
            languageCell.tap()
        }
    }
    
    func openSearchFilterByTransportation(){
        //Select : Search 4 Type
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(2).tap()
    }
    
    func pressSelectTransportation(){
        //Select : Specify Transportation
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_DETAIL_TABLE_VIEWS]
        searchFilterTableView.cells.elementBoundByIndex(1).tap()
    }
    
    func getSelectTransportationString() -> String{
        //Select : Specify Transportation
        let searchFilterTableView = app.tables[ID_SEARCH_FILTER_DETAIL_TABLE_VIEWS]
        let cell = searchFilterTableView.cells.elementBoundByIndex(1)
        return getDescriptionFromCell(cell)
    }
    
    func selectMainTransportation(selectIndex : UInt) -> String {
        let searchFilterMainTransportation = app.tables[ID_SEARCH_FILTER_JOB_CATEGORIES_TRANSPORT_TABLE_VIEWS]
        let cell = searchFilterMainTransportation.cells.elementBoundByIndex(selectIndex)
        let title = getTitleFromCell(cell)
        cell.tap()
        return title
    }
    
    func selectCategory(selectIndex : UInt) -> String {
        let searchFilterCategory = app.tables[ID_SEARCH_FILTER_JOB_CATEGORIES_TABLE_VIEWS]
        let cell = searchFilterCategory.cells.elementBoundByIndex(selectIndex)
        let title = getTitleFromCell(cell)
        cell.tap()
        return title
    }
    
    func selectSubCategory(selectIndex : UInt) -> String{
        let searchFilterSubCategory = app.tables[ID_SEARCH_FILTER_JOB_CATEGORIES_SUB_TABLE_VIEWS]
        let cell = searchFilterSubCategory.cells.elementBoundByIndex(selectIndex)
        let title = getTitleFromCell(cell)
        cell.tap()
        return title
    }

    func searchResultMapViewIsVisible() -> Bool {
        let searhResultMapViewController = app.otherElements[ID_SEARCH_RESULT_MAP_VIEWS]
        return searhResultMapViewController.exists
    }
    
    func pressSearchButton(){
        //Select : Search button
        let searchButton = app.buttons[ID_SEARCH_FILTER_QUICK_SEARCH_BUTTON]
        searchButton.tap()
    }
    
    //MARK: Utilities Function
    func getTitleFromCell(cell : XCUIElement) -> String {
        let title = cell.staticTexts.elementBoundByIndex(0).label
        return title
    }
    
    func getDescriptionFromCell(cell : XCUIElement) -> String {
        let title = cell.staticTexts.elementBoundByIndex(1).label
        return title
    }
    
    func pressedDonButton(){
        let doneButton = app.buttons.staticTexts["ตกลง"]
        if(doneButton.exists){
            doneButton.tap()
        }
    }
}
