//
//  JTMViewedCompany.swift
//  JobThai
//
//  Created by weerapon on 5/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMViewedCompanyTests: XCTestCase {
    
    private final let SLEEP_LAUNCH_APP : UInt32 = 3
    private final let SLEEP_FINISHED_APP : UInt32 = 1
    private final let SLEEP_WAITING_APP : UInt32 = 3
    
    let app = XCUIApplication()
    
    func testOpenJobDetail() {
        // func Base Launch App
        self.baseLaunchApp()
        
        // CollectionView Search and Click Companies Have Job Open
        let collectionView = app.collectionViews[VIEWED_BY_COMPANIES_COLLECTION_VIEWS]
        let availableJob = collectionView.cells.containingType(.Image, identifier: COMPANIES_IMAGE_AVALABLE_JOB)
        var isFoundAvailable = false
        
        sleep(self.SLEEP_WAITING_APP)
        
        // loop finding available job
        while collectionView.cells.element.exists {
            if availableJob.element.exists {
                // Select Cell Available Cell
                availableJob.elementBoundByIndex(0).tap()
                // Set Flag found available job
                isFoundAvailable = true
                
                sleep(self.SLEEP_WAITING_APP)
                // Check this is Jobdetail All Position
                XCTAssert(app.otherElements[ID_JOB_DETAIL_ALL_POSITION].exists)
                break
            }
            collectionView.swipeUp()
        }

        if !isFoundAvailable {
            XCTFail("Not found available job")
        }
        
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func testJobDetailClosedJob() {
        // func Base Launch App
        self.baseLaunchApp()
        
        // CollectionView Search and Click Companies Have Job Open
        let collectionView = app.collectionViews[VIEWED_BY_COMPANIES_COLLECTION_VIEWS]
        let closedJob = collectionView.cells.containingType(.Image, identifier: COMPANIES_IMAGE_CLOSE_JOB)
        var isFoundClosedJob = false
        
        sleep(self.SLEEP_WAITING_APP)
        
        // loop finding available job
        while collectionView.cells.element.exists {
            if closedJob.element.exists {
                // Select Cell Close Job Cell
                closedJob.elementBoundByIndex(0).tap()
                // Set Flag found available job
                isFoundClosedJob = true
                // Check this is Alert Close Job
                XCTAssert(app.alerts["alert"].exists)
                break
            }
            collectionView.swipeUp()
        }
        
        if (!isFoundClosedJob) {
            XCTFail("Not found closed job")
        }
        
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func testBackToTopButton() {
        // Mark-: Base Launch App
        self.baseLaunchApp()
        
        sleep(self.SLEEP_WAITING_APP)
        
        // CollectionView Search and Click Companies Have Job Open
        let collectionView = app.collectionViews[VIEWED_BY_COMPANIES_COLLECTION_VIEWS]
        let backToTopButton = app.buttons[BACKTOTOP_VIEWED_BY_COMPANY]
        var isFoundBackToTop = false
        
        while collectionView.cells.element.exists {
            collectionView.swipeUp()
            if backToTopButton.hittable {
                isFoundBackToTop = true
                backToTopButton.tap()
                sleep(SLEEP_WAITING_APP)
                XCTAssertTrue(collectionView.cells.elementBoundByIndex(0).hittable, "Not Scroll To Top")
                break
            }
        }
        
        if (!isFoundBackToTop) {
            XCTFail("Not found back to top")
        }
        
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func testLoadMore() {
        
        // Mark-: Base Launch App
        self.baseLaunchApp()
        
        sleep(self.SLEEP_WAITING_APP)
        
        // CollectionView Search and Click Companies Have Job Open
        let collectionView = app.collectionViews[VIEWED_BY_COMPANIES_COLLECTION_VIEWS]
        let cell = collectionView.cells[ID_VIEWED_BY_COMPANIES_LOAD_MORE]
        var isFinishedLoadMore = false
        
        while (collectionView.cells.element.exists) {
            if (cell.exists) {
                XCTAssertTrue(cell.hittable, "Load More")
                isFinishedLoadMore = true
                
                break
            } else {
                collectionView.swipeUp()
            }
        }
        
        if (!isFinishedLoadMore) {
            XCTFail("No Load More")
        }
        
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func testSearchButton() {
        // Mark-: Base Launch App
        self.baseLaunchApp()
        
        sleep(self.SLEEP_WAITING_APP)
        
        // Present Search Filter
        let searchBarButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_BUTTON]
        searchBarButton.tap()
        
        sleep(SLEEP_WAITING_APP)
        
        // Check OpenSearch Filter
        let searchFilterView = app.tables[ID_SEARCH_FILTER_TYPE_TABLE_VIEWS]
        XCTAssertTrue(searchFilterView.exists, "Not show present search")
        
        let cancelButton = app.buttons[ID_NAV_BAR_QUICK_SEARCH_CANCEL]
        cancelButton.tap()
        
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func testNoResult() {
        app.launch()
        
        // Waing for load app and set app
        sleep(self.SLEEP_WAITING_APP)
        
        // Logout and Login
        self.logOut()
        self.logInWithUserNoResult()
        
        // Select Hamburger Manu
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        
        // Select Index Viewed by companies
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        mainMenu.cells.elementBoundByIndex(4).tap()
        
        sleep(self.SLEEP_WAITING_APP)
        
        let collectionView = app.collectionViews[VIEWED_BY_COMPANIES_COLLECTION_VIEWS]
        let countCell = collectionView.cells.count
        
        XCTAssert(countCell < 1)
        sleep(self.SLEEP_FINISHED_APP)
    }
    
    func baseLaunchApp() {
        app.launch()
        
        // Waing for load app and set app
        sleep(self.SLEEP_WAITING_APP)
        
        // Logout and Login
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        if (mainMenu.cells.count == 8) {
            self.logOut()
            self.logInWithUserHaveAppliedJob()
        } else {
            self.logInWithUserHaveAppliedJob()
        }
        
        // Select Hamburger Manu
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        
        // Select Index Viewed by companies
        mainMenu.cells.elementBoundByIndex(4).tap()
    }

    func logInWithUserHaveAppliedJob() {
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(1).tap()
        
        let username = app.textFields["usernameTextField"]
        username.tap()
        username.clearText()
        username.typeText("vaiohkae@gmail.com")
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testuser")
        
        app.buttons["loginButton"].tap()
        
        sleep(self.SLEEP_WAITING_APP)
    }
    
    func logInWithUserNoResult() {
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(1).tap()
        
        let username = app.textFields["usernameTextField"]
        username.tap()
        username.clearText()
        username.typeText("jtmtester+04@gmail.com")
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testuser")
        
        app.buttons["loginButton"].tap()
        
        sleep(self.SLEEP_WAITING_APP)
    }
    
    func logOut() {
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        mainMenu.cells.elementBoundByIndex(7).tap()
        let alertLogOut = app.alerts[ID_ALERT_LOGOUT]
        let alertButtonLogOut = alertLogOut.collectionViews.buttons
        let LogOutButton = alertButtonLogOut.elementBoundByIndex(1)
        LogOutButton.tap()
    }
}


extension XCUIElementQuery {
    var countForHittables: UInt {
        return UInt(allElementsBoundByIndex.filter { $0.hittable }.count)
    }
}